var level3 = function (game) { };
level3.prototype = {
    mouseX: 0,
    oldMouseX: 0,
    itemSelected: null,
    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);
        //secondary
        this.load.image("background", "assets/Level_3/background.png");
        this.load.spritesheet("smallscenes0", "assets/Level_3/smallscenes0.png", 1024, 768);
        this.load.image("chessBoard", "assets/Level_3/chess/chessBoard.png");
        this.load.image("queen", "assets/Level_3/chess/queen.png");
        this.load.image("btnGameBackground", "assets/Level_3/btnGame/btnGameBackground.png");
        this.load.spritesheet("lightBtn", "assets/Level_3/btnGame/lightBtn.png", 130, 160);
        this.load.spritesheet("sprite_block", "assets/Level_3/sprite_block.png", 238, 475);
        this.load.image("dyska", "assets/Level_3/dyska.png");
        this.load.spritesheet("switch", "assets/Level_3/switch.png", 64, 100);
        this.load.spritesheet("praholqk", "assets/Level_3/praholqk.png", 681, 341);
        this.load.spritesheet("sprite_lost", "assets/Level_3/sprite_lost.png", 128, 256);
        this.load.image("dupka", "assets/Level_3/dupka.png");
        this.load.image("kofa", "assets/Level_3/kofa.png");
        this.load.spritesheet("sandyk", "assets/Level_3/sandyk.png", 411, 501);
        this.load.spritesheet("dupkaIgla", "assets/Level_3/dupkaIgla.png", 100, 100);
        this.load.spritesheet("btnGame", "assets/Level_3/btnGame.png", 290, 260);
        this.load.spritesheet("bqlSandyk", "assets/Level_3/bqlSandyk.png", 365, 297);

        //items
        this.load.image("vyjence", "assets/Level_3/items/vyjence.png");
        this.load.image("kuka", "assets/Level_3/items/kuka.png");
        this.load.image("svityk", "assets/Level_3/items/svityk.png");
        this.load.image("blockPadnal", "assets/Level_3/items/blockPadnal.png");
        this.load.image("konserva", "assets/Level_3/items/konserva.png");
        this.load.image("chetka", "assets/Level_3/items/chetka.png");
        this.load.image("piron", "assets/Level_3/items/piron.png");
        this.load.image("svitykPodDyska", "assets/Level_3/items/svitykPodDyska.png");
        this.load.spritesheet("dupkaVoda", "assets/Level_3/items/dupkaVoda.png", 128, 128);
        this.load.image("lost", "assets/Level_3/items/lost.png");
        this.load.image("svitykPrah", "assets/Level_3/items/svitykPrah.png");
        this.load.image("kluchZaSandyk", "assets/Level_3/items/kluchZaSandyk.png");
        //this.load.image("listVKofa", "assets/Level_3/items/listVKofa.png");
        this.load.image("igla", "assets/Level_3/items/igla.png");
        this.load.image("svitykZadButoni", "assets/Level_3/items/svitykZadButoni.png");
        this.load.image("kluchSandykDve", "assets/Level_3/items/kluchSandykDve.png");
        this.load.image("svitykShah", "assets/Level_3/items/svitykShah.png");

        //door puzzle items
        this.load.image("320i", "assets/Level_3/puzzles/320.png");
        this.load.image("321i", "assets/Level_3/puzzles/321.png");
        this.load.image("322i", "assets/Level_3/puzzles/322.png");
        this.load.image("323i", "assets/Level_3/puzzles/323.png");
        this.load.image("324i", "assets/Level_3/puzzles/324.png");
        this.load.image("325i", "assets/Level_3/puzzles/325.png");

        //hud items
        this.load.image("301", "assets/Level_3/HUD/301.png");
        this.load.image("302", "assets/Level_3/HUD/302.png");
        this.load.image("320", "assets/Level_3/HUD/303.png");
        this.load.image("304", "assets/Level_3/HUD/304.png");
        this.load.image("305", "assets/Level_3/HUD/305.png");
        this.load.image("306", "assets/Level_3/HUD/306.png");
        this.load.image("321", "assets/Level_3/HUD/303.png");
        this.load.image("308", "assets/Level_3/HUD/308.png");
        this.load.image("309", "assets/Level_3/HUD/309.png");
        this.load.image("310", "assets/Level_3/HUD/310.png");
        this.load.image("322", "assets/Level_3/HUD/303.png");
        this.load.image("312", "assets/Level_3/HUD/312.png");
        this.load.image("313", "assets/Level_3/HUD/313.png");
        this.load.image("315", "assets/Level_3/HUD/315.png");
        this.load.image("323", "assets/Level_3/HUD/303.png");
        this.load.image("317", "assets/Level_3/HUD/317.png");
        this.load.image("324", "assets/Level_3/HUD/303.png");
        this.load.image("325", "assets/Level_3/HUD/303.png");
    },
    create: function () {
        resetHintTimer(true);

        //resetingShits and basic stuff for a level
        GAMEMODE.levelNumber = 3;
        GAMEMODE.pointerToLevel = this;
        this.cameraXBeforeSmallScene = 512;
        this.cameraMove = false;
        this.paused = false;
        this.videoPlaying = false;
        this.itemSelected = null;
        this.mouseX = 0;
        this.oldMouseX = 0;

        //stek sydyrjasht listove ot itemi, koito da se kriqt
        this.itemsToHide = [];
        //list sydyrjasht actiori, koito moje da tick- vat
        this.tickingActors = {};
        setUpALevel(this);
        makeHUDItems(this);

        ////reseting other basic variable sfor this particular level
        //this.videoManager = {};
        //this.videoManager[GAMEMODE.videoNames[5]] = false;

        this.btnGameFinished = false;

        this.chess = this.createChess();

        this.lightBtnGame = this.createLightBtnGame();

        //otlqvo scena
        this.leftWall = addActor(this, 145, 246, "camera", 400, 401, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.konserva.taken) {
                    game.konserva.visible = true;
                }

                if (!game.chetka.taken) {
                    game.chetka.visible = true;
                }

                game.praholqk.visible = true;

                game.dupkaZaLost.visible = true;

                if (game.lostPostaven) {
                    game.lostPostaven.visible = true;
                }

                if (game.dupkaVPoda) {
                    game.dupkaVPoda.visible = true;
                }

                if (game.kofa) {
                    game.kofa.visible = true;
                }

                if (game.praholqk.frame === 2) {
                    //sloji itemite koito sa vytre po princip
                    if (!game.lost.taken) {
                        game.lost.visible = true;
                    }
                    if (!game.svitykPrah.taken) {
                        game.svitykPrah.visible = true;
                    }
                }
            },
            getListToHide: function (game) {
                var returnV = [];
                if (!game.konserva.taken) {
                    returnV.push(game.konserva);
                }

                if (!game.chetka.taken) {
                    returnV.push(game.chetka);
                }

                returnV.push(game.praholqk);

                returnV.push(game.dupkaZaLost);

                if (game.lostPostaven) {
                    returnV.push(game.lostPostaven);
                }

                if (game.dupkaVPoda) {
                    returnV.push(game.dupkaVPoda);
                }

                if (game.kofa) {
                    returnV.push(game.kofa);
                }
                if (game.praholqk.frame === 2) {
                    //sloji itemite koito sa vytre po princip
                    if (!game.lost.taken) {
                        returnV.push(game.lost);
                    }
                    if (!game.svitykPrah.taken) {
                        returnV.push(game.svitykPrah);
                    }
                }

                return returnV;
            }
        }, true);
        //otdqsno stena
        this.rightWall = addActor(this, 1610, 302, "camera", 200, 200, 3, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.blockMiddle.visible = true;
                game.dyska.visible = true;
                if (game.blockMiddle.id === 105) {
                    if (!game.kuka.taken) {
                        game.kuka.visible = true;
                    }
                    if (!game.svityk.taken) {
                        game.svityk.visible = true;
                    }
                    if (!game.blockPadnal.taken) {
                        game.blockPadnal.visible = true;
                    }
                }
            },
            getListToHide: function (game) {
                var returnV = [];
                returnV.push(game.blockMiddle);
                returnV.push(game.dyska);
                if (game.blockMiddle.id === 105) {
                    if (!game.kuka.taken) {
                        returnV.push(game.kuka);
                    }
                    if (!game.svityk.taken) {
                        returnV.push(game.svityk);
                    }
                    if (!game.blockPadnal.taken) {
                        returnV.push(game.blockPadnal);
                    }
                }
                return returnV;
            }
        }, true);
        //centralna stena
        this.centerWall = addActor(this, 704, 210, "camera", 650, 250, 2, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.vyjence.taken) {
                    game.vyjence.visible = true;
                }
                if (!game.svitykCepka.taken) {
                    game.svitykCepka.visible = true;
                }

                game.switch.visible = true;
                game.dupkaIgla.visible = true;
                game.btnGameStarter.visible = true;

                game.door.show();
            },
            getListToHide: function (game) {
                var returnV = [];
                if (!game.vyjence.taken) {
                    returnV.push(game.vyjence);
                }
                if (!game.svitykCepka.taken) {
                    returnV.push(game.svitykCepka);
                }
                returnV.push(game.switch);
                returnV.push(game.dupkaIgla);
                returnV.push(game.btnGameStarter);

                returnV = game.door.pushToHideArray(returnV);

                return returnV;
            }
        }, true);
        //kufarche
        this.kufarche = addActor(this, 791, 491, "camera", 390, 170, 4, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.sandyk.visible = true;

                if (game.sandyk.frame === 1 && !game.igla.taken) {
                    game.igla.visible = true;
                }
            },
            getListToHide: function (game) {
                var returnV = [];

                returnV.push(game.sandyk);

                if (game.sandyk.frame === 1 && !game.igla.taken) {
                    returnV.push(game.igla);
                }

                return returnV;
            }
        }, true);

        //others
        //block na stenata, koito se dyrpa
        this.blockMiddle = addActor(this, 406, 0, "sprite_block", 284, 568, 101, true, function (e) {
            if (e.id === 101 && this.itemSelected && this.itemSelected.id === 301) {
                removeItemFromHUD(this);
                e.frame = 1;
                e.id = 102;
            }
            else if (e.id === 102) {
                e.frame = 2;
                e.id = 105;
                //add the new item with the rope and block
                this.kuka.visible = true;
                this.svityk.visible = true;
                this.blockPadnal.visible = true;
                this.pushAtTopListToHide([this.kuka, this.svityk, this.blockPadnal]);
            }
        }, this, false);

        this.dyska = addActor(this, 403, 585, "dyska", 80, 170, 103, true, function (e) {
            if (e.id === 103) {
                e.loadTexture("camera");
                setSizeActor(e, 80, 170);
                e.id = 6;
            }
            else if (e.id === 6) {
                this.handleSmallScenes.apply({
                    event: this,
                    scene: this.smallScene,
                    visibilityAndActionHandler: function (game) {
                        game.popListToHide();
                        var newListToPop = [];
                        if (!game.piron.taken) {
                            game.piron.visible = true;
                            newListToPop.push(game.piron);
                        }
                        if (!game.svitykPodDyska.taken) {
                            game.svitykPodDyska.visible = true;
                            newListToPop.push(game.svitykPodDyska);
                        }
                        game.dupkaVoda.visible = true;
                        newListToPop.push(game.dupkaVoda);
                        game.itemsToHide.push(newListToPop);
                    }
                }, [e]);
            }
        }, this, false);

        this.switch = addActor(this, 192, 87, "switch", 64, 100, 104, true, function (e) {
            if (this.dupkaIgla.frame === 1) {
                e.frame = 1;
                this.btnGameStarter.frame = 1;
            }
        }, this, false);

        this.praholqk = addActor(this, 350, 0, "praholqk", 681, 341, 106, true, function (e) {
            if (e.id === 106 && this.itemSelected && this.itemSelected.id === 305) {
                removeItemFromHUD(this);
                e.frame = 1;
                e.id = 107;
            }
            else if (e.id === 107 && this.itemSelected && this.itemSelected.id === 309) {
                removeItemFromHUD(this);
                e.frame = 2;
                e.id = 108;
                this.lost.visible = true;
                this.svitykPrah.visible = true;
                this.pushAtTopListToHide([this.lost, this.svitykPrah]);
            }
        }, this, false);

        this.dupkaVoda = addActor(this, 278, 424, "dupkaVoda", 128, 128, 109, true, function (e) {
            if (e.id === 109 && this.itemSelected && this.itemSelected.id === 308) {
                removeItemFromHUD(this);
                e.frame = 1;
                e.id = 309;
                e.taken = false;
            }
            else if (e.id === 309 && e.frame === 1) {
                takeItem.apply({ game: this }, [e]);
                e.visible = true;
                e.frame = 2;
            }
        }, this, false);

        this.lostPostaven = null;

        this.dupkaVPoda = null;

        this.kofa = null;

        this.dupkaZaLost = addActor(this, 768, 657, "camera", 100, 100, 110, true, function (e) {
            if (this.itemSelected && this.itemSelected.id === 310) {
                removeItemFromHUD(this);
                this.lostPostaven = addActor(this, 761, 465, "sprite_lost", 128, 256, 111, true, function (e) {
                    if (e.frame === 0) {
                        e.frame = 1;
                        e.x = 777;
                        e.y = 466;
                        this.dupkaVPoda = addActor(this, 515, 649, "dupka", 274, 110, 112, true, function (e) {
                            if (this.itemSelected && this.itemSelected.id === 312) {
                                removeItemFromHUD(this);
                                this.kofa = addActor(this, 376, 564, "kofa", 200, 200, 7, true, this.handleSmallScenes, {
                                    event: this,
                                    scene: this.smallScene,
                                    visibilityAndActionHandler: function (game) {
                                        game.popListToHide();
                                        var listToHide = [];

                                        if (!game.kluchZaSandyk.taken) {
                                            game.kluchZaSandyk.visible = true;
                                            listToHide.push(game.kluchZaSandyk);
                                        }

                                        //if (!game.listVKofa.taken) {
                                        //    game.listVKofa.visible = true;
                                        //    listToHide.push(game.listVKofa);
                                        //}

                                        game.itemsToHide.push(listToHide);
                                    }
                                }, true);
                                this.pushAtTopListToHide([this.kofa]);
                            }
                        }, this, true);
                        this.pushAtTopListToHide([this.dupkaVPoda]);
                    }
                }, this, true);
                this.pushAtTopListToHide([this.lostPostaven]);
            }
        }, this, false);

        this.sandyk = addActor(this, 238, 67, "sandyk", 534, 650, 112, true, function (e) {
            if (e.frame === 0 && this.itemSelected && this.itemSelected.id === 313) {
                removeItemFromHUD(this);
                e.frame = 1;
                this.igla.visible = true;
                this.pushAtTopListToHide([this.igla]);
                e.id = 5;
            }
            else if (e.frame === 1) {
                this.handleSmallScenes.apply({
                    event: this,
                    scene: this.smallScene,
                    visibilityAndActionHandler: function (game) {
                        game.popListToHide();
                        var newListToPop = [];
                        game.bqlSandyk.visible = true;
                        newListToPop.push(game.bqlSandyk);

                        if (game.bqlSandyk.frame === 2 && !game.svitykShah.taken) {
                            //add the items to be taken
                            game.svitykShah.visible = true;
                        }
                        newListToPop.push(game.svitykShah);

                        game.itemsToHide.push(newListToPop);
                    }
                }, [e]);
            }
        }, this, false);

        this.dupkaIgla = addActor(this, 201, 519, "dupkaIgla", 100, 100, 113, true, function (e) {
            if (e.frame === 0 && this.itemSelected && this.itemSelected.id === 315) {
                removeItemFromHUD(this);
                e.frame = 1;
            }
        }, this, false);

        this.btnGameStarter = addActor(this, 58, 200, "btnGame", 290, 260, 114, true, function (e) {
            if (!this.btnGameFinished && e.frame === 1) {
                //start the game
                this.lightBtnGame.setUp();
            }
            else if (this.btnGameFinished) {
                this.handleSmallScenes.apply({
                    event: this,
                    scene: this.smallScene,
                    visibilityAndActionHandler: function (game) {
                        game.popListToHide();
                        var newListToPop = [];
                        if (!game.svitykZadButoni.taken) {
                            game.svitykZadButoni.visible = true;
                            newListToPop.push(game.svitykZadButoni);
                        }
                        if (!game.kluchSandykDve.taken) {
                            game.kluchSandykDve.visible = true;
                            newListToPop.push(game.kluchSandykDve);
                        }

                        game.itemsToHide.push(newListToPop);
                    }
                }, [e]);
            }
        }, this, false);

        this.bqlSandyk = addActor(this, 335, 257, "bqlSandyk", 365, 297, 115, true, function (e) {
            if (e.frame === 0 && this.itemSelected && this.itemSelected.id === 317) {
                removeItemFromHUD(this);
                e.frame = 1;
            }
            else if (e.frame === 1) {
                //start the final game
                this.chess.setUp();
            }
        }, this, false);

        this.door = this.createDoor();
        this.door.create();

        //take- able items
        this.vyjence = addTakableItem(addActor(this, 543, 655, "vyjence", 481, 120, 301, true,
takeItem, { game: this }, false));
        this.svityk = addTakableItem(addActor(this, 423, 55, "svityk", 244, 94, 320, true,
takeItem, { game: this }, false));
        this.kuka = addTakableItem(addActor(this, 415, 59, "kuka", 94, 100, 302, true,
takeItem, { game: this }, false));
        this.blockPadnal = addTakableItem(addActor(this, 680, 498, "blockPadnal", 242, 181, 301, true,
takeItem, { game: this }, false));
        this.konserva = addTakableItem(addActor(this, 58, 581, "konserva", 64, 65, 304, true,
takeItem, { game: this }, false));
        this.chetka = addTakableItem(addActor(this, 369, 635, "chetka", 120, 60, 305, true,
takeItem, { game: this }, false));
        this.piron = addTakableItem(addActor(this, 838, 451, "piron", 32, 64, 306, true,
takeItem, { game: this }, false));
        this.svitykPodDyska = addTakableItem(addActor(this, 471, 419, "svitykPodDyska", 446, 128, 321, true,
takeItem, { game: this }, false));
        //308 probita konserva
        //309 klyuch ot pod dyska za klyuchalka v stenata skrita ot praholqk
        this.lost = addTakableItem(addActor(this, 408, 237, "lost", 180, 32, 310, true,
takeItem, { game: this }, false));
        this.svitykPrah = addTakableItem(addActor(this, 473, 217, "svitykPrah", 156, 64, 322, true,
takeItem, { game: this }, false));
        //312 vyjeSKuka
        this.kluchZaSandyk = addTakableItem(addActor(this, 519, 344, "kluchZaSandyk", 270, 350, 313, true,
takeItem, { game: this }, false));
        /*this.listVKofa = addTakableItem(addActor(this, 208, 198, "listVKofa", 250, 450, 323, true,
takeItem, { game: this }, false));*/
        this.igla = addTakableItem(addActor(this, 358, 195, "igla", 300, 64, 315, true,
takeItem, { game: this }, false));
        this.svitykZadButoni = addTakableItem(addActor(this, 455, 596, "svitykZadButoni", 260, 180, 323, true,
takeItem, { game: this }, false));
        this.kluchSandykDve = addTakableItem(addActor(this, 429, 558, "kluchSandykDve", 180, 180, 317, true,
takeItem, { game: this }, false));
        this.svitykShah = addTakableItem(addActor(this, 470, 423, "svitykShah", 120, 60, 324, true,
takeItem, { game: this }, false));
        this.svitykCepka = addTakableItem(addActor(this, 764, 220, "camera", 100, 200, 325, true,
takeItem, { game: this }, false));

        //showing the HUD above everything else
        this.bringHUDToTop();

        //show ad
        showInterstitial();
    },
    update: function () {
        if (!this.paused) {
            if (this.cameraMove && !this.smallScene.shown) {
                this.mouseX = this.input.x;
                this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
                if (this.cameraMan.x > 1536)
                    this.cameraMan.x = 1536;
                else if (this.cameraMan.x < 512)
                    this.cameraMan.x = 512;
                //compute the kolelce new frame
                var razlika = this.mouseX - this.kolelce.lastMoved;
                if (Math.abs(razlika) > 20 && this.cameraMan.x != 512 && this.cameraMan.x != 1536) {
                    var direction = razlika > 0 ? -1 : 1;
                    this.kolelce.frame = this.kolelce.frame === 0 && direction === -1 ? 2 : (this.kolelce.frame + direction) % 3;
                    this.kolelce.lastMoved = this.mouseX;
                }

                this.oldMouseX = this.mouseX;
            }
        }
        for (var property in this.tickingActors) {
            if (this.tickingActors.hasOwnProperty(property) && this.tickingActors[property].isTicking) {
                this.tickingActors[property].tick();
            }
        }
    },
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.event.paused) {
            //resets cameraview
            this.event.cameraXBeforeSmallScene = this.event.cameraMan.x;
            this.event.cameraMan.x = 512;

            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
                this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
            this.scene.frame = (e.id - 1) % 8;
            this.scene.shown = true;

            //ako trqbva specialni neshta ako trqbva da se pokajat
            if (this.visibilityHandlerShow !== null)
                this.visibilityHandlerShow(this.event);

            //vkarva list s itemite koito trqbva da se skriqt
            if (this.getListToHide) {
                var list = this.getListToHide(this.event);
                if (list) {
                    this.event.itemsToHide.push(list);
                }
            }
            //adds back Btnton
            this.event.backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene
            }, 0, 0, 1);
        }
    },
    handleSmallScenes: function (e) {
        if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
            this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
        this.scene.id = e.id;
        this.scene.frame = (e.id - 1) % 8;
        if (this.visibilityAndActionHandler)
            this.visibilityAndActionHandler(this.event);
    },
    videoHandler: function (e) {
        var pointerToThis = this;
        if (!this.game.videoManager[this.videoName]) {
            //otbelqzva tova video kato gledano
            this.game.videoManager[this.videoName] = true;

            //pause music videoto
            if (MUSICMANAGER.musicON || MUSICMANAGER.volumeFXs === 1) {
                pauseMusicForVideo();
            }

            GAMEMODE.pointerToLevel.videoPlaying = true;
            playPlayer(game.videos[this.videoName]);
            setTimeout(function () {
                game.videos[pointerToThis.videoName].callback();
                if (e) {
                    e.destroy();
                    e = null;
                }
            }, 2000);
        }
    },
    backBtnHandler: function (e) {
        if (!this.videoPlaying) {
            this.event.cameraMan.x = this.event.cameraXBeforeSmallScene;
            this.scene.width = 0;
            this.scene.height = 0;
            this.scene.id = -1;
            this.scene.shown = false;

            while (this.event.itemsToHide.length > 0)
                this.event.popListToHide();
            e.kill();
            this.event.backBtn = null;
        }
    },
    popListToHide: function () {
        var list = this.itemsToHide.pop();
        for (var i = 0; i < list.length; i++)
            if (list[i] && list[i].visible)
                list[i].visible = false;
    },
    pushAtTopListToHide: function (list) {
        for (var i = 0; i < list.length; i++) {
            this.itemsToHide[this.itemsToHide.length - 1].push(list[i]);
        }
    },
    bringHUDToTop: function () {
        this.HUD.bringToTop();
        for (var i = 0; i < 4; i++)
            this.hudItems[i].bringToTop();
        this.selector.bringToTop();
    },
    createChess: function () {
        var top = { x: 202, y: 55 };
        var chess = {};
        chess.mainActor = null;
        chess.backBtn = null;
        chess.queens = [];
        chess.conflicts = [];
        chess.countConflicts = 0;

        function generateSquares() {
            var squares = [];
            for (var i = 0; i < 8; i++) {
                for (var j = 0; j < 8; j++) {
                    squares.push({ x: top.x + (80 * j), y: top.y + (80 * i) })
                }
            }

            return squares;
        }

        function generateBoolBoard() {
            var board = {};
            board.mainBools = [];
            for (var i = 0; i < 8; i++) {
                board.mainBools[i] = new Array(8);
            }

            board.clearBools = function () {
                for (var i = 0; i < 8; i++) {
                    for (var j = 0; j < 8; j++) {
                        board.mainBools[i][j] = false;
                    }
                }
            }

            board.clearBools();

            return board;
        }

        function checkIfTwoQueensAreInConflict(q1, q2) {
            if ((q1.x === q1.startX && q1.y === q1.startY) || (q2.x === q2.startX && q2.y === q2.startY)) {
                return false;
            }

            return q1.x === q2.x || q1.y === q2.y || Math.abs(q1.x - q2.x) === Math.abs(q1.y - q2.y);
        }

        function getSquareCoordsOfQueensInConflict(q1, q2) {
            if (q1.y === q2.y) {
                var retV = [];
                var startEnd = q1.x > q2.x ? [q2.x + 80, q1.x] : [q1.x + 80, q2.x];

                while (startEnd[0] < startEnd[1]) {
                    var coordsToAdd = [startEnd[0], q1.y];
                    if (!chess.checkIfAQueenIsThere(coordsToAdd)) {
                        retV.push([startEnd[0], q1.y]);
                    }
                    startEnd[0] += 80;
                }

                return retV;
            }

            if (q1.x === q2.x) {
                var retV = [];
                var startEnd = q1.y > q2.y ? [q2.y + 80, q1.y] : [q1.y + 80, q2.y];

                while (startEnd[0] < startEnd[1]) {
                    var coordsToAdd = [q1.x, startEnd[0]];
                    if (!chess.checkIfAQueenIsThere(coordsToAdd)) {
                        retV.push([q1.x, startEnd[0]]);
                    }
                    startEnd[0] += 80;
                }

                return retV;
            }

            var retV = [];
            var startEnd;
            var startEnd2;
            var direction = 1;
            if (q1.x > q2.x) {
                var startEnd = [q2.x + 80, q1.x];
                var startEnd2 = [q2.y + 80, q1.y];
                if (q2.y > q1.y) {
                    startEnd2[0] -= 160;
                    direction = -1;
                }
            }
            else {
                var startEnd = [q1.x + 80, q2.x];
                var startEnd2 = [q1.y + 80, q2.y];
                if (q1.y > q2.y) {
                    startEnd2[0] -= 160;
                    direction = -1;
                }
            }
            while (startEnd[0] < startEnd[1]) {
                var coordsToAdd = [startEnd[0], startEnd2[0]];
                if (!chess.checkIfAQueenIsThere(coordsToAdd)) {
                    retV.push([startEnd[0], startEnd2[0]]);
                }
                startEnd[0] += 80;
                startEnd2[0] = startEnd2[0] + (direction * 80);
            }

            return retV;
        }

        function dropQueenHandler(e) {
            var squareLeft = this.chess.checkInWhichSquare(e.x + e.width / 2, e.y + e.height / 2);
            if (squareLeft /*&& !chess.checkIfAQueenIsThere([squareLeft.x,squareLeft.y])*/) {
                e.x = squareLeft.x;
                e.y = squareLeft.y;
            }
            else {
                e.x = e.startX;
                e.y = e.startY;
            }
            if (chess.checkConflicts() === 0 && chess.countQueensOnBoard() === 8) {
                GAMEMODE.pointerToLevel.bqlSandyk.frame = 2;
                GAMEMODE.pointerToLevel.svitykShah.visible = true;

                chess.destroyIt();
            }
        }

        chess.squares = generateSquares();

        chess.boolBoard = generateBoolBoard();

        chess.checkInWhichSquare = function (x, y) {
            for (var i = 0 ; i < chess.squares.length; i++) {
                var sq = chess.squares[i];
                if (x >= sq.x && x < sq.x + 80 && y >= sq.y && y < sq.y + 80) {
                    return sq;
                }
            }

            return null;
        }

        chess.checkConflicts = function () {
            console.log("Starting to check");
            chess.conflicts.forEach(function (member) {
                member.destroy();
                member = null;
            });
            chess.conflicts = [];
            chess.countConflicts = 0;
            chess.boolBoard.clearBools();
            chess.clearAllColors();

            for (var i = 0 ; i < chess.queens.length; i++) {
                for (var j = i + 1; j < chess.queens.length; j++) {
                    if (chess.queens[i].id !== chess.queens[j].id && checkIfTwoQueensAreInConflict(chess.queens[i], chess.queens[j])) {
                        //console.log("I found conflict betweeen queens");
                        chess.colorTwoQueens(chess.queens[i], chess.queens[j]);
                        var coords = getSquareCoordsOfQueensInConflict(chess.queens[i], chess.queens[j]);
                        var bBoard = chess.boolBoard.mainBools;
                        coords.forEach(function (member) {
                            var iIndex = (member[0] - top.x) / 80;
                            var jIndex = (member[1] - top.y) / 80;
                            if (!this.bBoard[iIndex][jIndex]) {
                                this.bBoard[iIndex][jIndex] = true;
                                this.confList.push(addActor(GAMEMODE.pointerToLevel, member[0], member[1], "tester", 81, 81, 920, false, {}, {}, true));
                                this.confList[this.confList.length - 1].tint = 0x610707;
                            }
                        }, { bBoard: bBoard, confList: chess.conflicts });

                        chess.countConflicts++;
                    }
                }
            }

            chess.bringQueensToTheTop();
            return chess.countConflicts;
        }

        chess.checkIfAQueenIsThere = function (coords) {
            for (var i = 0; i < chess.queens.length; i++) {
                var member = chess.queens[i];
                if (member.x === coords[0] && member.y === coords[1]) {
                    return true;
                }
            }
            return false;
        }

        chess.colorTwoQueens = function (q1, q2) {
            if (q1.tint === 16777215) {
                q1.tint = 0xd32020;
            }
            if (q2.tint === 16777215) {
                q2.tint = 0xd32020;
            }
        }

        chess.clearAllColors = function () {
            chess.queens.forEach(function (member) {
                member.tint = 16777215;
            });
        }

        chess.setUp = function () {
            GAMEMODE.pointerToLevel.paused = true;
            chess.mainActor = addActor(GAMEMODE.pointerToLevel, 0, 0, "chessBoard", 1024, 768, 900, true, function () { }, {}, true);
            chess.queens = [];
            chess.conflicts = [];
            chess.backBtn = null;
            chess.countConflicts = 0;

            for (var i = 0; i < 4; i++) {
                chess.queens.push(addActor(GAMEMODE.pointerToLevel, 82, 161 + 100 * i, "queen", 80, 80, 901 + i, true, dropQueenHandler, GAMEMODE.pointerToLevel, true));
            }

            for (var i = 0; i < 4; i++) {
                chess.queens.push(addActor(GAMEMODE.pointerToLevel, 870, 161 + 100 * i, "queen", 80, 80, 904 + i, true, dropQueenHandler, GAMEMODE.pointerToLevel, true));
            }

            chess.queens.forEach(function (member) {
                member.startX = member.x;
                member.startY = member.y;
                member.input.enableDrag(true);
            });

            chess.backBtn = GAMEMODE.pointerToLevel.add.button(10, 630, "backBtn", function () {
                chess.destroyIt();
            }, GAMEMODE.pointerToLevel, 0, 0, 1);
        }

        chess.countQueensOnBoard = function () {
            var counter = 0;
            chess.queens.forEach(function (member) {
                if (member.x !== member.startX && member.y !== member.startY) {
                    counter++;
                }
            });

            return counter;
        }

        chess.bringQueensToTheTop = function () {
            chess.queens.forEach(function (member) {
                member.bringToTop();
            });
        }

        chess.destroyIt = function () {
            GAMEMODE.pointerToLevel.paused = false;
            chess.mainActor.destroy();
            chess.mainActor = null;
            for (var i = 0; i < chess.queens.length; i++) {
                chess.queens[i].destroy();
                chess.queens[i] = null;
            }
            chess.queens = [];

            chess.conflicts.forEach(function (member) {
                member.destroy();
                member = null;
            });

            chess.conflicts = [];

            chess.backBtn.destroy();
        }

        return chess;
    },
    createLightBtnGame: function () {
        var lightBtnGame = {};
        lightBtnGame.backBtn = null;
        lightBtnGame.btns = [];

        function getNeighboursIndexes(coords) {
            var retList = [];
            function checkIfCorect(i, j) {
                return i >= 0 && i < 4 && j >= 0 && j < 4;
            }
            if (checkIfCorect(coords[0] + 1, coords[1])) {
                retList.push((coords[0] + 1) * 4 + coords[1]);
            }
            if (checkIfCorect(coords[0], coords[1] + 1)) {
                retList.push((coords[0]) * 4 + coords[1] + 1);
            }
            if (checkIfCorect(coords[0] - 1, coords[1])) {
                retList.push((coords[0] - 1) * 4 + coords[1]);
            }
            if (checkIfCorect(coords[0], coords[1] - 1)) {
                retList.push((coords[0]) * 4 + coords[1] - 1);
            }

            return retList;
        }

        function btnClickHandler(e) {
            var neighbours = getNeighboursIndexes(e.id);
            neighbours.forEach(function (member) {
                switchColor(lightBtnGame.btns[member]);
            });
            var counter = 0;
            lightBtnGame.btns.forEach(function (member) {
                if (member.frame === 1) {
                    counter++;
                }
            });

            if (counter === 16) {
                //end game
                GAMEMODE.pointerToLevel.btnGameFinished = true;
                GAMEMODE.pointerToLevel.btnGameStarter.id = 8;
                setTimeout(function () {
                    lightBtnGame.destroy();
                    GAMEMODE.pointerToLevel.handleSmallScenes.apply({
                        event: GAMEMODE.pointerToLevel,
                        scene: GAMEMODE.pointerToLevel.smallScene,
                        visibilityAndActionHandler: function (game) {
                            game.popListToHide();
                            var newListToPop = [];
                            if (!game.svitykZadButoni.taken) {
                                game.svitykZadButoni.visible = true;
                                newListToPop.push(game.svitykZadButoni);
                            }
                            if (!game.kluchSandykDve.taken) {
                                game.kluchSandykDve.visible = true;
                                newListToPop.push(game.kluchSandykDve);
                            }

                            game.itemsToHide.push(newListToPop);
                        }
                    }, [GAMEMODE.pointerToLevel.btnGameStarter]);
                }, 1000);
            }
        }

        function switchColor(btn) {
            btn.frame = btn.frame === 0 ? 1 : 0;
        }

        lightBtnGame.setUp = function () {
            GAMEMODE.pointerToLevel.paused = true;
            lightBtnGame.btns = [];

            this.mainActor = addActor(GAMEMODE.pointerToLevel, 0, 0, "btnGameBackground", 1024, 768, 900, true, function () { }, {}, true);
            var startX = 177;
            var startY = 30;
            for (var i = 0; i < 4 ; i++) {
                for (var j = 0; j < 4 ; j++) {
                    lightBtnGame.btns.push(addActor(GAMEMODE.pointerToLevel, startX + (i * 160), startY + (j * 170), "lightBtn", 130, 160, [i, j], true, btnClickHandler, GAMEMODE.pointerToLevel, true));
                }
            }

            lightBtnGame.backBtn = null;
            lightBtnGame.backBtn = GAMEMODE.pointerToLevel.add.button(10, 630, "backBtn", function () {
                lightBtnGame.destroy();
            }, GAMEMODE.pointerToLevel, 0, 0, 1);
        }

        lightBtnGame.destroy = function () {
            lightBtnGame.mainActor.destroy();
            lightBtnGame.mainActor = null;

            lightBtnGame.btns.forEach(function (member) {
                member.destroy();
                member = null;
            });
            lightBtnGame.btns = [];

            lightBtnGame.backBtn.destroy();

            GAMEMODE.pointerToLevel.paused = false;
        }

        return lightBtnGame;
    },
    createDoor: function () {
        var door = {};
        door.pieces = [];
        var coordsPlaces = {
            0: { x: 361, y: 58 },
            1: { x: 361, y: 258 },
            2: { x: 361, y: 458 },
            3: { x: 536, y: 58 },
            4: { x: 536, y: 258 },
            5: { x: 536, y: 458 }
        };

        var answers = {
            0: "322i",
            1: "324i",
            2: "325i",
            3: "320i",
            4: "323i",
            5: "321i"
        };

        function checkIfOnAPiece(coords, piece) {
            return coords.x >= piece.x && coords.x <= piece.x + piece.width && coords.y >= piece.y && coords.y <= piece.y + piece.height;
        }

        function switchPiecePlaces(piece1, piece2) {
            var oneX = coordsPlaces[piece1.place].x, oneY = coordsPlaces[piece1.place].y, swap = piece1.place;
            piece1.x = piece2.x;
            piece1.y = piece2.y;
            piece2.x = oneX;
            piece2.y = oneY;

            piece1.place = piece2.place;
            piece2.place = swap;
        }

        function goToNextLevel() {
            if (GAMEMODE.openedLevels === 3) {
                GAMEMODE.openedLevels = 4;
                saveData(GAMEMODE.openedLevels, GAMEMODE.likedFB, GAMEMODE.watchedAd, MUSICMANAGER.musicON, MUSICMANAGER.volumeFXs, GAMEMODE.tutorial);
            }

            GAMEMODE.pointerToLevel.state.start("Level4");

            //if (GAMEMODE.watchedAd == 0 && ADSMANAGER.ready) {
            //    ADSMANAGER.type = "Level3";
            //    var objForSending = { moreInfo: "After level 3 without ads" };
            //    addWatchedAd(objForSending);
            //    playAd();
            //}
            //else {
            //    GAMEMODE.pointerToLevel.state.start("Level4");
            //}
        }

        function piecesClickHandler(e) {
            if (e.key === "camera" && this.itemSelected &&
                (this.itemSelected.id >= 320 && this.itemSelected.id <= 325)) {
                e.loadTexture(this.itemSelected.id + "i");
                e.width = 175;
                e.height = 200;
                removeItemFromHUD(this);
                if (door.checkIfWin()) {
                    goToNextLevel();
                }
                else {
                    e.input.enableDrag(true);
                    e.events.onInputDown.add(function () {
                        if (!GAMEMODE.pointerToLevel.paused) {
                            e.bringToTop();
                        }
                    }, this);
                }
            }
            else {
                var found = false;
                for (var i = 0; i < door.pieces.length; i++) {
                    if (e.place !== door.pieces[i].place && checkIfOnAPiece({
                        x: e.x + e.width / 2,
                        y: e.y + e.height / 2
                    }, door.pieces[i]) && !found) {
                        found = true;
                        switchPiecePlaces(e, door.pieces[i]);
                        break;
                    }
                }
                if (!found) {
                    e.x = coordsPlaces[e.place].x;
                    e.y = coordsPlaces[e.place].y;
                }
                else if (door.checkIfWin()) {
                    goToNextLevel();
                }
            }
        }

        door.create = function () {
            var startX = 361;
            var startY = 58;
            for (var i = 0; i < 2 ; i++) {
                for (var j = 0; j < 3 ; j++) {
                    door.pieces.push(addActor(GAMEMODE.pointerToLevel, startX + (i * 175), startY + (j * 200), "camera", 175, 200, 600 + (i*3 + j), true, piecesClickHandler, GAMEMODE.pointerToLevel, false));
                    door.pieces[door.pieces.length - 1].place = (3 * i + j);
                }
            }
        }

        door.show = function () {
            door.pieces.forEach(function (member) {
                member.visible = true;
            });
        }

        door.pushToHideArray = function (array) {
            door.pieces.forEach(function (member) {
                array.push(member);
            });

            return array;
        }

        door.checkIfWin = function () {
            var counter = 0;
            door.pieces.forEach(function (member) {
                if (answers[member.place] === member.key) {
                    counter++;
                }
            });

            return counter === 6;
        }

        return door;
    }
};
