var level4 = function (game) { };
level4.prototype = {
    mouseX: 0,
    oldMouseX: 0,
    itemSelected: null,
    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);
        //secondary
        this.load.image("background", "assets/Level_4/background.png");
        this.load.spritesheet("smallscenes0", "assets/Level_4/smallscenes0.png", 1024, 768);
        this.load.spritesheet("smallscenes1", "assets/Level_4/smallscenes1.png", 1024, 768);
        this.load.spritesheet("vaseSheet", "assets/Level_4/vazaSheet.png", 300, 461);
        this.load.spritesheet("vazaBigScene", "assets/Level_4/vazaBigScene.png", 160, 497);
        this.load.spritesheet("kukuvica", "assets/Level_4/spritesheet_kukuvica.png", 326, 332);
        this.load.image("list_blizo", "assets/Level_4/MiniGame1/list_blizo.png");
        this.load.image("list_shkaf", "assets/Level_4/item_list_na_shkaf.png");
        this.load.image("komiksPrazen", "assets/Level_4/komiksPrazen.png");
        this.load.image("komiksPylen", "assets/Level_4/komiksPylen.png");
        this.load.image("malkaStrelka", "assets/Level_4/item_strelka2t2.png");
        this.load.image("golqmaStrelka", "assets/Level_4/item_strelka1.png");
        this.load.spritesheet("mahalo_chasovnik", "assets/Level_4/spritesheet_mahalo_chasovnik.png", 245, 408);
        this.load.image("glina_gryncharsko", "assets/Level_4/glina_gryncharsko.png");
        this.load.image("vaza_ot_gryncharsko", "assets/Level_4/vaza_ot_gryncharsko.png");
        this.load.image("vaza_Za_dupka", "assets/Level_4/vaza_Za_dupka.png");


        //minigame
        this.load.image("epr_1", "assets/Level_4/MiniGame1/1.png");
        this.load.image("epr_2", "assets/Level_4/MiniGame1/2.png");
        this.load.image("epr_3", "assets/Level_4/MiniGame1/3.png");
        this.load.image("epr_4", "assets/Level_4/MiniGame1/4.png");
        this.load.image("epr_5", "assets/Level_4/MiniGame1/5.png");
        this.load.image("epr_6", "assets/Level_4/MiniGame1/6.png");
        this.load.image("epr_7", "assets/Level_4/MiniGame1/7.png");
        this.load.spritesheet("kolbi", "assets/Level_4/MiniGame1/kolbi.png", 223, 275);
        this.load.image("rules", "assets/Level_4/MiniGame1/list.png");

        //minigame2
        this.load.spritesheet("target", "assets/Level_4/MiniGame2/target.png", 64, 64);
        this.load.spritesheet("shootBtn", "assets/Level_4/MiniGame2/shootBtn.png", 256, 128);
        this.load.image("kloun_v_legen", "assets/Level_4/MiniGame2/kloun_v_legen.png");
        this.load.image("item_clown", "assets/Level_4/MiniGame2/item_clown.png");
        this.load.image("item_papagalche", "assets/Level_4/MiniGame2/item_papagalche.png");
        this.load.image("item_mishena_pavilion", "assets/Level_4/MiniGame2/item_mishena_pavilion.png");

        //items
        this.load.image("prysten", "assets/Level_4/items/prysten.png");
        this.load.image("trion", "assets/Level_4/items/trion.png");
        this.load.image("kolba", "assets/Level_4/items/kolba.png");
        this.load.image("dyska", "assets/Level_4/items/dyska.png");
        this.load.image("chetka", "assets/Level_4/items/chetka.png");
        this.load.image("dyska_za_kloun", "assets/Level_4/items/dyska_za_kloun.png");
        this.load.image("tikso", "assets/Level_4/items/tikso.png");
        this.load.image("glina_v_shkaf", "assets/Level_4/items/glina_v_shkaf.png");

        //hud items
        this.load.image("401", "assets/Level_4/HUD/401.png");
        this.load.image("402", "assets/Level_4/HUD/402.png");
        this.load.image("403", "assets/Level_4/HUD/403.png");
        this.load.image("404", "assets/Level_4/HUD/404.png");
        this.load.image("405", "assets/Level_4/HUD/405.png");
        this.load.image("406", "assets/Level_4/HUD/406.png");
        this.load.image("407", "assets/Level_4/HUD/407.png");
        this.load.image("408", "assets/Level_4/HUD/408.png");
        this.load.image("409", "assets/Level_4/HUD/409.png");
        this.load.image("410", "assets/Level_4/HUD/410.png");
        this.load.image("411", "assets/Level_4/HUD/411.png");
        this.load.image("412", "assets/Level_4/HUD/412.png");
        this.load.image("413", "assets/Level_4/HUD/413.png");
        this.load.image("414", "assets/Level_4/HUD/414.png");
        this.load.image("415", "assets/Level_4/HUD/415.png");

    },
    create: function () {
        resetHintTimer(true);

        //resetingShits and basic stuff for a level
        GAMEMODE.levelNumber = 4;
        GAMEMODE.pointerToLevel = this;
        this.cameraXBeforeSmallScene = 512;
        this.cameraMove = false;
        this.paused = false;
        this.videoPlaying = false;
        this.itemSelected = null;
        this.mouseX = 0;
        this.oldMouseX = 0;

        //stek sydyrjasht listove ot itemi, koito da se kriqt
        this.itemsToHide = [];
        //list sydyrjasht actiori, koito moje da tick- vat
        this.tickingActors = {};
        setUpALevel(this);
        makeHUDItems(this);

        ////reseting other basic variable sfor this particular level
        this.videoManager = {};
        this.videoManager[GAMEMODE.videoNames[6]] = false;
        this.videoManager[GAMEMODE.videoNames[7]] = false;
        this.videoManager[GAMEMODE.videoNames[8]] = false;

        //set up the sounds
        this.setUpSounds();

        this.leftSide = addActor(this, 86, 234, "camera", 350, 400, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.chekmedje.visible = true;
                game.chasovnik.visible = true;
                game.stihotvorenie.visible = true;
                if (!game.trion.taken) {
                    game.trion.visible = true;
                }
                game.mahaloZaChasovnik.visible = true;
            },
            getListToHide: function (game) {
                var returnV = [];

                returnV.push(game.chekmedje);
                returnV.push(game.chasovnik);
                returnV.push(game.stihotvorenie);
                if (!game.trion.taken) {
                    returnV.push(game.trion);
                }
                returnV.push(game.mahaloZaChasovnik);

                return returnV;
            }
        }, true);

        this.mashinaGlina = addActor(this, 548, 459, "camera", 170, 170, 2, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.pedalMashina.visible = true;
                if (!game.mqstoZaGlina.taken) {
                    game.mqstoZaGlina.visible = true;
                }
                if (!game.duckTape.taken) {
                    game.duckTape.visible = true;
                }
            },
            getListToHide: function (game) {
                var returnV = [];

                returnV.push(game.pedalMashina);
                if (!game.mqstoZaGlina.taken) {
                    returnV.push(game.mqstoZaGlina);
                }
                if (!game.duckTape.taken) {
                    returnV.push(game.duckTape);
                }

                return returnV;
            }
        }, true);

        this.legloShkaf = addActor(this, 1183, 377, "camera", 170, 270, 3, true, function (e) {
            if (!this.videoManager[GAMEMODE.videoNames[7]]) {
                this.videoHandler.apply({ game: this, videoName: GAMEMODE.videoNames[7] }, []);
            }
            else {
                this.changeSmallScenes.apply({
                    event: this,
                    scene: this.smallScene,
                    visibilityHandlerShow: function (game) {
                        game.shkafIgrachki.visible = true;
                        if (!game.kolba.taken) {
                            game.kolba.visible = true;
                        }
                        if (!game.dyska.taken) {
                            game.dyska.visible = true;
                        }
                    },
                    getListToHide: function (game) {
                        var returnV = [];

                        returnV.push(game.shkafIgrachki);
                        if (!game.kolba.taken) {
                            returnV.push(game.kolba);
                        }

                        if (!game.dyska.taken) {
                            returnV.push(game.dyska);
                        }

                        return returnV;
                    }
                }, [e]);
            }
        }, this, true);

        this.vase = addActor(this, 968, 78, "vazaBigScene", 160, 497, 4, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.vaseItem.visible = true;
            },
            getListToHide: function (game) {
                var returnV = [];

                returnV.push(game.vaseItem);

                return returnV;
            }
        }, true);

        this.door = addActor(this, 772, 228, "camera", 170, 370, 5, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                game.mqstoZaVaza.visible = true;
                game.vrata.visible = true;
            },
            getListToHide: function (game) {
                var returnV = [];
                returnV.push(game.mqstoZaVaza);
                returnV.push(game.vrata);

                return returnV;
            }
        }, true);

        //mejdinni sceni
        this.chekmedje = addActor(this, 590, 599, "camera", 170, 170, 6, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                //include files that are going to be visible on the next scene
                game.himichnaIgra.visible = true;
                game.itemsToHide.push([game.himichnaIgra]);
            }
        }, false);

        this.chasovnik = addActor(this, 73, 67, "camera", 170, 170, 7, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                //include files that are going to be visible on the next scene
                game.watch.show();
                game.itemsToHide.push([game.watch.kukuvica, game.watch.malkaStrelka, game.watch.golqmaStrelka]);
            }
        }, false);

        this.shkafIgrachki = addActor(this, 130, 291, "camera", 170, 170, 8, true, function(e){
            if (!this.videoManager[GAMEMODE.videoNames[8]]) {
                this.videoHandler.apply({ game: this, videoName: GAMEMODE.videoNames[8] }, []);
            }
            else {
                this.handleSmallScenes.apply({
                    event: this,
                    scene: this.smallScene,
                    visibilityAndActionHandler: function (game) {
                        game.popListToHide();
                        var itemsToHide = [];
                        //include files that are going to be visible on the next scene
                        if (!game.prysten.taken) {
                            game.prysten.visible = true;
                            itemsToHide.push(game.prysten);
                        }
                        game.listNaShkaf.visible = true;
                        itemsToHide.push(game.listNaShkaf);

                        game.itemsToHide.push(itemsToHide);
                    }
                }, [e]);
            }
        }, this , false);
        //usable Items
        this.dyska = addActor(this, 601, 122, "dyska", 75, 355, 404, true, function (e) {
            if (this.itemSelected && this.itemSelected.id === 402) {
                removeItemFromHUD(this);
                takeItem.apply({ game: this }, [e]);
            }
        }, this, false);
        this.vaseItem = addActor(this, 243, 0, "camera", 500, 768, 100, true, function (e) {
            if (this.itemSelected && this.itemSelected.id === 401) {
                removeItemFromHUD(this);
                e.loadTexture("vaseSheet");
                this.vase.frame = 1;
                setSizeActor(e, 500, 768);
                e.id = 101;
            }
            else if (e.id === 101) {
                e.changed = false;
                this.backBtn.visible = false;
                e.frame = 1;
                e.id = 405;
                //if it is not changed for 3 seconds
                setTimeout(function () {
                    if (!e.changed) {
                        //play the video
                        GAMEMODE.pointerToLevel.videoHandler.apply({ game: GAMEMODE.pointerToLevel, videoName: GAMEMODE.videoNames[6] }, []);
                    }
                }, 3000);
            }
            else if (e.id === 405 && this.itemSelected && this.itemSelected.id === 406) {
                removeItemFromHUD(this);
                takeItem.apply({ game: this }, [e]);
                e.visible = true;
                e.id = 102;
                e.frame = 2;
                this.vase.frame = 2;
                e.changed = true;
                GAMEMODE.pointerToLevel.backBtn.visible = true;
            }
        }, this, false);

        this.himichnaIgra = addActor(this, 273, 495, "camera", 200, 120, 9, true, function (e) {
            if (((this.itemSelected && this.itemSelected.id === 403) || this.himichnaIgra.unlocked) && !this.himichnaIgra.prizeTaken) {
                if (!this.himichnaIgra.unlocked) {
                    removeItemFromHUD(this);
                    this.himichnaIgra.unlocked = true;
                }
                e.gameItSelf.setUp();
                e.gameItSelf.restart();
            }
        }, this, false);
        this.himichnaIgra.gameItSelf = this.createHimichnaIgra();
        this.himichnaIgra.completed = false;
        this.himichnaIgra.unlocked = false;
        this.himichnaIgra.prizeTaken = false;

        this.pavilion = addActor(this, 1707, 162, "camera", 190, 450, 10, true, function (e) {
            this.gamePavilion.setUp();
        }, this, true);
        this.gamePavilion = this.createPavilion();

        this.komiks = null;
        this.komiksShown = false;
        this.listNaShkaf = addActor(this, 743, 668, "list_shkaf", 267, 93, 110, true, function (e) {
            if (!this.komiks) {
                var key = !this.komiksShown ? "komiksPrazen" : "komiksPylen";
                this.komiks = addActor(this, 210, 11, key, 548, 621, 111, true, function (e) {
                    if (this.itemSelected && this.itemSelected.id === 409) {
                        removeItemFromHUD(this);
                        e.loadTexture("komiksPylen");
                        setSizeActor(e, 548, 621);
                        this.komiksShown = true;
                    }
                }, this, true);
                this.add.button(10, 630, "backBtn", function (e) {
                    this.komiks.destroy();
                    this.komiks = null;
                    e.destroy();
                }, this, 0, 0, 1)
            }
        }, this, false);

        this.watch = this.createWatch();
        this.watch.setUp();

        this.mahaloZaChasovnik = addActor(this, 83, 182, "camera", 190, 408, 130, true, function (e) {
            if (e.id === 130 && this.itemSelected && this.itemSelected.id === 412) {
                removeItemFromHUD(this);
                e.id = 131;
                //sloji mahaloto
                e.loadTexture("mahalo_chasovnik");
                setSizeActor(e, 245, 408);
                this.watch.mahaloSlojeno = true;
                this.watch.isSomethingAboutToHappen();
            }
            if (e.id === 11) {
                //ako e razbito smeni scenata s handle small scenes
                this.handleSmallScenes.apply({
                    event: this,
                    scene: this.smallScene,
                    visibilityAndActionHandler: function (game) {
                        game.popListToHide();
                        var newListToPop = [];
                        //TO DO: sloji glinata ako ne e taken veche
                        if (!game.glina.taken) {
                            game.glina.visible = true;
                            newListToPop.push(game.glina);
                        }
                        game.itemsToHide.push(newListToPop);
                    }
                }, [e]);
            }
        }, this, false);

        this.pedalMashina = addActor(this, 594, 645, "camera", 100, 100, 140, true, function (e) {
            if (this.glinaPostavena && this.mqstoZaGlina.id === 150) {
                //TO DO: Pravish itema da e schupenata vaza i da moje da se vzima
                this.mqstoZaGlina.id = 406;
                this.mqstoZaGlina.loadTexture("vaza_ot_gryncharsko");
                setSizeActor(this.mqstoZaGlina, 308, 587);
                this.mqstoZaGlina.x = 294;
                this.mqstoZaGlina.y = 42;
            }
        }, this, false);
        this.glinaPostavena = false;

        this.mqstoZaGlina = addActor(this, 362, 75, "camera", 200, 200, 150, true, function (e) {
            if (e.id === 150 && this.itemSelected && this.itemSelected.id === 413) {
                removeItemFromHUD(this);
                //TO DO:
                //change texture
                e.loadTexture("glina_gryncharsko");
                setSizeActor(e, 147, 119);
                this.glinaPostavena = true;
            }
            if (e.id === 406) {
                takeItem.apply({ game: this }, [e]);
            }
        }, this, false);
        this.mqstoZaGlina.taken = false;

        this.mqstoZaVaza = addActor(this, 642, 150, "camera", 200, 450, 160, true, function (e) {
            if (e.id === 160 && this.itemSelected && this.itemSelected.id === 405) {
                removeItemFromHUD(this);
                //TO DO:
                //change texture
                e.loadTexture("vaza_Za_dupka");
                setSizeActor(e, 205, 528);
                e.x = 606;
                e.y = 101;
                this.hubavaVasaPostavena = true;
            }
        }, this, false);
        this.hubavaVasaPostavena = false;

        this.vrata = addActor(this, 44, 232, "camera", 440, 450, 170, true, function (e) {
            if (this.hubavaVasaPostavena) {
                if (GAMEMODE.openedLevels === 4) {
                    GAMEMODE.openedLevels = 5;
                    saveData(GAMEMODE.openedLevels, GAMEMODE.likedFB, GAMEMODE.watchedAd, MUSICMANAGER.musicON, MUSICMANAGER.volumeFXs, GAMEMODE.tutorial);
                }

                GAMEMODE.pointerToLevel.state.start("Level5");

                //if (GAMEMODE.watchedAd == 1 && ADSMANAGER.ready) {
                //    ADSMANAGER.type = "Level4";
                //    var objForSending = { moreInfo: "After level 4 without ads" };
                //    addWatchedAd(objForSending);
                //    playAd();
                //}
                //else {
                //    GAMEMODE.pointerToLevel.state.start("Level5");
                //}
            }
        }, this, false);

        this.stihotvorenie = addActor(this, 814, 210, "camera", 120, 160, 170, true, function (e) {
            var stihotvorenie = "The Big Ben will be needed again\n" +
            "You have to set the hours to be three\n" +
            "After the little bird is free.\n" +
            "Don't forget about the big arrow too\n" +
            "It's (this level's number + 1) * two";

            function alertDismissed() { }
            navigator.notification.alert(stihotvorenie,  // message
                alertDismissed,         // callback
                'Poem',            // title
                'OK'            // buttonName
                );
        }, this, false);

        //takable items
        this.prysten = addTakableItem(addActor(this, 418, 657, "prysten", 72, 92, 401, true,
takeItem, { game: this }, false));
        this.trion = addTakableItem(addActor(this, 453, 666, "trion", 128, 128, 402, true,
takeItem, { game: this }, false));
        this.kolba = addTakableItem(addActor(this, 373, 501, "kolba", 127, 167, 403, true,
takeItem, { game: this }, false));
        //404 dyska
        //405 istinska vaza
        //406 fal6iva vaza
        //407 pylna kolba
        //408 normalna chetka
        //409 namokrena chetka
        //410 kukuvica
        //411 mishena za mahalo
        //412 mahalo
        //413 glina
        this.glina = addTakableItem(addActor(this, 578, 426, "glina_v_shkaf", 75, 119, 413, true,
takeItem, { game: this }, false));
        //414 ducktape
        this.duckTape = addTakableItem(addActor(this, 682, 561, "tikso", 80, 82, 414, true,
takeItem, { game: this }, false));
        //415 dyska i mishena kombinirani

        //bringing the top buttons to the top
        bringTopMenuToTop(this);

        //showing the HUD above everything else
        this.bringHUDToTop();

        //show ad
        showInterstitial();
    },
    update: function () {
        if (!this.paused) {
            if (this.cameraMove && !this.smallScene.shown) {
                this.mouseX = this.input.x;
                this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
                if (this.cameraMan.x > 1536)
                    this.cameraMan.x = 1536;
                else if (this.cameraMan.x < 512)
                    this.cameraMan.x = 512;
                //compute the kolelce new frame
                var razlika = this.mouseX - this.kolelce.lastMoved;
                if (Math.abs(razlika) > 20 && this.cameraMan.x != 512 && this.cameraMan.x != 1536) {
                    var direction = razlika > 0 ? -1 : 1;
                    this.kolelce.frame = this.kolelce.frame === 0 && direction === -1 ? 2 : (this.kolelce.frame + direction) % 3;
                    this.kolelce.lastMoved = this.mouseX;
                }

                this.oldMouseX = this.mouseX;
            }
        }
        for (var property in this.tickingActors) {
            if (this.tickingActors.hasOwnProperty(property) && this.tickingActors[property].isTicking) {
                this.tickingActors[property].tick();
            }
        }
    },
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.event.paused) {
            //resets cameraview
            this.event.cameraXBeforeSmallScene = this.event.cameraMan.x;
            this.event.cameraMan.x = 512;

            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
                this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
            this.scene.frame = (e.id - 1) % 8;
            this.scene.shown = true;

            //ako trqbva specialni neshta ako trqbva da se pokajat
            if (this.visibilityHandlerShow !== null)
                this.visibilityHandlerShow(this.event);

            //vkarva list s itemite koito trqbva da se skriqt
            if (this.getListToHide) {
                var list = this.getListToHide(this.event);
                if (list) {
                    this.event.itemsToHide.push(list);
                }
            }
            //adds back Btnton
            this.event.backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene
            }, 0, 0, 1);
        }
    },
    handleSmallScenes: function (e) {
        if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
            this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
        this.scene.id = e.id;
        this.scene.frame = (e.id - 1) % 8;
        if (this.visibilityAndActionHandler)
            this.visibilityAndActionHandler(this.event);
    },
    videoHandler: function (e) {
        var pointerToThis = this;
        if (!this.game.videoManager[this.videoName]) {
            //otbelqzva tova video kato gledano
            this.game.videoManager[this.videoName] = true;

            //pause music videoto
            if (MUSICMANAGER.musicON || MUSICMANAGER.volumeFXs === 1) {
                pauseMusicForVideo();
            }

            GAMEMODE.pointerToLevel.videoPlaying = true;
            playPlayer(game.videos[this.videoName]);
            setTimeout(function () {
                game.videos[pointerToThis.videoName].callback();
                if (e) {
                    e.destroy();
                    e = null;
                }
            }, 2000);
        }
    },
    backBtnHandler: function (e) {
        if (!this.videoPlaying) {
            this.event.cameraMan.x = this.event.cameraXBeforeSmallScene;
            this.scene.width = 0;
            this.scene.height = 0;
            this.scene.id = -1;
            this.scene.shown = false;

            while (this.event.itemsToHide.length > 0)
                this.event.popListToHide();
            e.kill();
            this.event.backBtn = null;
        }
    },
    popListToHide: function () {
        var list = this.itemsToHide.pop();
        for (var i = 0; i < list.length; i++)
            if (list[i] && list[i].visible)
                list[i].visible = false;
    },
    pushAtTopListToHide: function (list) {
        for (var i = 0; i < list.length; i++) {
            this.itemsToHide[this.itemsToHide.length - 1].push(list[i]);
        }
    },
    bringHUDToTop: function () {
        this.HUD.bringToTop();
        for (var i = 0; i < 4; i++)
            this.hudItems[i].bringToTop();
        this.selector.bringToTop();
    },
    createHimichnaIgra: function () {
        var chemGame = {};
        var actorsCoords = {
            1: { x: 529, y: 148, color: "blue" },
            2: { x: 591, y: 156, color: "blue" },
            3: { x: 650, y: 167, color: "yellow" },
            4: { x: 712, y: 174, color: "yellow" },
            5: { x: 772, y: 189, color: "green" },
            6: { x: 841, y: 200, color: "white" },
            7: { x: 918, y: 200, color: "white" },
        }
        var colorMap = {
            "fail": 0,
            "yellow": 1,
            "success": 2,
            "white": 3,
            "blue": 4,
            "green": 5
        }
        function returnToOriginalPosition(actor, index) {
            actor.x = actorsCoords[index].x;
            actor.y = actorsCoords[index].y;
        }
        function isOverlappingWithKolba(actor) {
            return chemGame.kolba.x <= actor.x + actor.width / 2 && chemGame.kolba.x + chemGame.kolba.width >= actor.x + actor.width / 2 &&
                chemGame.kolba.y <= actor.y + actor.height / 2 && chemGame.kolba.y + chemGame.kolba.height >= actor.y + actor.height / 2;
        }
        function napylniKolbata(epruvetka) {
            chemGame.kolba.frame = colorMap[actorsCoords[epruvetka.id].color];
            epruvetka.visible = false;
            returnToOriginalPosition(epruvetka, epruvetka.id);
        }
        function smesi(epruvetka) {
            switch (actorsCoords[epruvetka.id].color) {
                case "blue": {
                    if (!chemGame.prevYellow) {
                        chemGame.order.push("blue");
                        napylniKolbata(epruvetka);
                        return true;
                    }
                    break;
                }
                case "white": {
                    chemGame.order.push("white");
                    napylniKolbata(epruvetka);
                    if (chemGame.prevYellow) {
                        chemGame.prevYellow = false;
                    }
                    return true;
                }
                case "green": {
                    if (!chemGame.prevYellow) {
                        chemGame.order.push("green");
                        napylniKolbata(epruvetka);
                        return true;
                    }
                    break;
                }
                case "yellow": {
                    var indexOfOldBlue = chemGame.order.length - 3;
                    if (!chemGame.prevYellow && indexOfOldBlue >= 0 && chemGame.order[indexOfOldBlue] === "blue") {
                        chemGame.order.push("green");
                        napylniKolbata(epruvetka);
                        chemGame.prevYellow = true;
                        return true;
                    }
                }
            }
            return false;
        }
        chemGame.kolba = null;
        chemGame.bigRules = null;
        chemGame.smallRules = null;
        chemGame.actors = [];
        chemGame.order = [];
        chemGame.prevYellow = false;
        chemGame.setUp = function () {
            if (!GAMEMODE.pointerToLevel.himichnaIgra.completed) {
                chemGame.actors.push(addActor(GAMEMODE.pointerToLevel, 0, 0, "smallscenes1", 1024, 768, 500, true, function () { }, GAMEMODE.pointerToLevel, false));
                chemGame.smallRules = addActor(GAMEMODE.pointerToLevel, 555, 482, "rules", 317, 224, 501, true, function (e) {
                    if (this.himichnaIgra.gameItSelf.bigRules) {
                        this.himichnaIgra.gameItSelf.bigRules.visible = true;
                    }
                    e.visible = false;
                }, GAMEMODE.pointerToLevel, false);
                chemGame.actors.push(chemGame.smallRules);
                chemGame.kolba = addActor(GAMEMODE.pointerToLevel, 260, 326, "kolbi", 223, 275, 407, false, null, null, false);
                chemGame.kolba.frame = colorMap["white"];
                chemGame.actors.push(chemGame.kolba);

                for (var i = 1; i < 8; i++) {
                    var epr = addActor(GAMEMODE.pointerToLevel, actorsCoords[i].x, actorsCoords[i].y, "epr_" + i, 64, 275, i, true, function (e) { }, GAMEMODE.pointerToLevel, false);
                    if (i === 5) {
                        epr.angle += 1;
                    }
                    if (i === 6) {
                        epr.angle += 3;
                    }
                    if (i === 7) {
                        epr.angle += 7;
                    }
                    epr.input.enableDrag(true);
                    epr.events.onInputUp.add(function (e) {
                        if (!isOverlappingWithKolba(e)) {
                            returnToOriginalPosition(e, e.id);
                        }
                        else {
                            if (!smesi(e)) {
                                chemGame.kolba.frame = colorMap["fail"];
                                function alertDismissed() { }
                                navigator.notification.alert("You've done something wrong",  // message
                                    alertDismissed,         // callback
                                    'Game Over',            // title
                                    'Try Again'            // buttonName
                                    );
                                //restart
                                returnToOriginalPosition(e, e.id);
                                chemGame.restart();
                            }
                            else {
                                if (chemGame.order.length === 7) {
                                    chemGame.kolba.frame = colorMap["success"];
                                    GAMEMODE.pointerToLevel.himichnaIgra.completed = true;
                                    //add takeItem click handler na kolbata
                                    chemGame.kolba.inputEnabled = true;
                                    chemGame.kolba.events.onInputUp.add(function (e) {
                                        if (takeItem.apply({ game: this }, [e])) {
                                            this.himichnaIgra.prizeTaken = true;
                                            chemGame.destroy();
                                        }
                                    }, GAMEMODE.pointerToLevel);
                                    GAMEMODE.pointerToLevel.bringHUDToTop();
                                }
                            }

                        }
                    }, GAMEMODE.pointerToLevel);
                    chemGame.actors.push(epr);
                }
                chemGame.bigRules = addActor(GAMEMODE.pointerToLevel, 219, 30, "list_blizo", 555, 656, 505, true, function (e) {
                    e.visible = false;
                    chemGame.smallRules.visible = true;
                }, GAMEMODE.pointerToLevel, false);
                chemGame.actors.push(chemGame.bigRules);

                chemGame.actors.push(GAMEMODE.pointerToLevel.add.button(10, 630, "backBtn", chemGame.backBtnHandler, GAMEMODE.pointerToLevel, 0, 0, 1));
                GAMEMODE.pointerToLevel.helpBtn.bringToTop();
            }
            else if (!GAMEMODE.pointerToLevel.himichnaIgra.prizeTaken) {
                chemGame.actors.push(addActor(GAMEMODE.pointerToLevel, 0, 0, "smallscenes1", 1024, 768, 500, true, function () { }, GAMEMODE.pointerToLevel, false));
                chemGame.kolba = addActor(GAMEMODE.pointerToLevel, 260, 326, "kolbi", 223, 275, 407, true, function (e) {
                    if (takeItem.apply({ game: this }, [e])) {
                        this.himichnaIgra.prizeTaken = true;
                        chemGame.destroy();
                    }
                }, GAMEMODE.pointerToLevel, false);
                chemGame.kolba.frame = colorMap["success"];
                chemGame.actors.push(chemGame.kolba);
                chemGame.actors.push(GAMEMODE.pointerToLevel.add.button(10, 630, "backBtn", chemGame.destroy, GAMEMODE.pointerToLevel, 0, 0, 1));

                GAMEMODE.pointerToLevel.bringHUDToTop();
                GAMEMODE.pointerToLevel.helpBtn.bringToTop();
            }
        }
        chemGame.restart = function () {
            chemGame.order = [];
            chemGame.prevYellow = false;
            if (!GAMEMODE.pointerToLevel.himichnaIgra.completed) {
                chemGame.kolba.frame = colorMap["white"];
            }
            chemGame.actors.forEach(function (actor) {
                if (actor.id !== 505) {
                    actor.visible = true;
                }
            });
        }
        chemGame.backBtnHandler = function () {
            if (chemGame.bigRules.visible) {
                chemGame.bigRules.visible = false;
                chemGame.smallRules.visible = true;
            }
            else {
                chemGame.destroy();
            }
        }
        chemGame.destroy = function () {
            chemGame.actors.forEach(function (actor) {
                actor.destroy();
            });
            chemGame.actors = [];
            chemGame.kolba = null;
            chemGame.bigRules = null;
            chemGame.smallRules = null;
        }
        return chemGame;
    },
    createWatch: function () {
        var chas = 1;
        var minuti = 0;
        var watch = {};
        watch.kukuvichkaShown = false;
        watch.kukuvichkaTaken = false;
        watch.mahaloSlojeno = false;
        watch.locked = false;
        watch.setUp = function () {
            watch.kukuvica = addActor(GAMEMODE.pointerToLevel, 293, 247, "kukuvica", 326, 332, 410, true, function (e) {
                if (e.frame === 0 && takeItem.apply({ game: this }, [e])) {
                    watch.kukuvichkaTaken = true;
                    watch.kukuvichkaShown = false;
                    watch.malkaStrelka.visible = true;
                    watch.golqmaStrelka.visible = true;
                    watch.kukuvica.destroy();
                    watch.kukuvica = null;
                }
            }, GAMEMODE.pointerToLevel, false);
            watch.kukuvica.frame = 1;
            watch.malkaStrelka = addActor(GAMEMODE.pointerToLevel, 459, 396, "malkaStrelka", 88, 235, 500, true, function (e) {
                if (!watch.locked) {
                    e.angle = (e.angle + 30) % 360;
                    chas = (chas + 1) % 12;
                    //check if something intresting happens
                    watch.isSomethingAboutToHappen();
                }
            }, GAMEMODE.pointerToLevel, false);
            watch.malkaStrelka.anchor.setTo(0.5, 1);
            watch.malkaStrelka.angle += 30;
            watch.golqmaStrelka = addActor(GAMEMODE.pointerToLevel, 457, 408, "golqmaStrelka", 65, 278, 500, true, function (e) {
                if (!watch.locked) {
                    e.angle = (e.angle + 30) % 360;
                    minuti = (minuti + 1) % 12;
                    //check if something intresting happens
                    watch.isSomethingAboutToHappen();
                }
            }, GAMEMODE.pointerToLevel, false);
            watch.golqmaStrelka.anchor.setTo(0.5, 1);
        }

        watch.show = function () {
            if (watch.kukuvichkaShown) {
                //pokaji samo kukuvichkata
                watch.kukuvica.visible = true;
            }
            else {
                if (watch.kukuvica) {
                    watch.kukuvica.visible = true;
                }
                watch.malkaStrelka.visible = true;
                watch.golqmaStrelka.visible = true;
            }
        }

        watch.isSomethingAboutToHappen = function () {
            if (!this.kukuvichkaTaken && !this.kukuvichkaShown && chas === 9 && minuti === 4) {
                //play sound!!!
                if (MUSICMANAGER.kukuvichka) {
                    MUSICMANAGER.kukuvichka.play();
                }
                this.kukuvica.frame = 0;
                this.kukuvichkaShown = true;
                this.malkaStrelka.visible = false;
                this.golqmaStrelka.visible = false;
            }
            else if (this.kukuvichkaTaken && this.mahaloSlojeno && chas === 3 && minuti === 2) {
                this.locked = true;
                //TO DO: do more logic
                GAMEMODE.pointerToLevel.mahaloZaChasovnik.id = 11;
                //TO DO: change texture na mahaloto vse edno e razbito
                GAMEMODE.pointerToLevel.mahaloZaChasovnik.frame = 1;
                //play sound
                if (MUSICMANAGER.bell) {
                    MUSICMANAGER.bell.play();
                }
            }
        }

        return watch;
    },
    createPavilion: function () {
        var pavilion = {};
        var tween;
        pavilion.chetkaTaken = false;
        pavilion.papagalSlojen = false;
        pavilion.gameCompleted = false;
        pavilion.pavilionShown = false;
        pavilion.mishenaTaken = false;
        pavilion.canShoot = true;

        pavilion.target = null;
        pavilion.btnShoot = null;
        pavilion.prychka = null;
        pavilion.mishena = null;
        pavilion.clownLegen = null;
        pavilion.clown = null;
        pavilion.actors = [];

        pavilion.setUp = function () {
            if (!pavilion.pavilionShown) {
                pavilion.pavilionShown = true;
                //resets cameraview
                GAMEMODE.pointerToLevel.cameraXBeforeSmallScene = GAMEMODE.pointerToLevel.cameraMan.x;
                GAMEMODE.pointerToLevel.cameraMan.x = 512;

                pavilion.actors.push(addActor(GAMEMODE.pointerToLevel, 0, 0, "smallscenes1", 1024, 768, 500, true, function () { }, GAMEMODE.pointerToLevel, true));
                pavilion.actors[0].frame = 1;
                if (!pavilion.chetkaTaken) {
                    pavilion.actors.push(addActor(GAMEMODE.pointerToLevel, 788, 629, "chetka", 72, 60, 408, true, function (e) {
                        if (takeItem.apply({ game: this }, [e])) {
                            pavilion.chetkaTaken = true;
                        }
                    }, GAMEMODE.pointerToLevel, true));
                }

                if (!pavilion.gameCompleted) {
                    pavilion.clown = addActor(GAMEMODE.pointerToLevel, 395, 362, "item_clown", 55, 79, 500, false, null, null, true);
                    pavilion.actors.push(pavilion.clown);
                }

                if (!pavilion.papagalSlojen) {
                    pavilion.actors.push(addActor(GAMEMODE.pointerToLevel, 586, 593, "camera", 90, 90, 500, true, function (e) {
                        if (this.itemSelected && this.itemSelected.id === 410) {
                            removeItemFromHUD(this);
                            e.loadTexture("item_papagalche");
                            setSizeActor(e, 32, 56);
                            e.x = 596;
                            pavilion.papagalSlojen = true;
                            pavilion.startGame();
                        }
                    }, GAMEMODE.pointerToLevel, true));
                }
                else {
                    pavilion.actors.push(addActor(GAMEMODE.pointerToLevel, 596, 593, "item_papagalche", 32, 56, 500, false, null, null, true));
                }

                pavilion.clownLegen = addActor(GAMEMODE.pointerToLevel, 372, 456, "kloun_v_legen", 114, 95, 500, false, null, null, true);
                pavilion.clownLegen.visible = pavilion.gameCompleted;
                pavilion.actors.push(pavilion.clownLegen);

                if (!pavilion.mishenaTaken) {
                    pavilion.mishena = addActor(GAMEMODE.pointerToLevel, 389, 445, "item_mishena_pavilion", 149, 87, 411, true, function (e) {
                        if (pavilion.gameCompleted && takeItem.apply({ game: this }, [e])) {
                            pavilion.mishenaTaken = true;
                        }
                    }, GAMEMODE.pointerToLevel, true);
                    pavilion.mishena.anchor.setTo(1, 0.5);
                    if (pavilion.gameCompleted) {
                        pavilion.mishena.rotation -= 45;
                    }
                    pavilion.actors.push(pavilion.mishena);

                }

                pavilion.prychka = addActor(GAMEMODE.pointerToLevel, 381, 445, "dyska_za_kloun", 92, 25, 411, false, null, null, true);
                pavilion.prychka.anchor.setTo(0, 0.5);
                if (pavilion.gameCompleted) {
                    pavilion.prychka.rotation += 45;
                    pavilion.prychka.x = 379;
                    pavilion.prychka.y = 438;
                }
                pavilion.actors.push(pavilion.prychka);

                if (pavilion.papagalSlojen && !pavilion.gameCompleted) {
                    pavilion.startGame();
                }

                pavilion.actors.push(GAMEMODE.pointerToLevel.add.button(10, 630, "backBtn", pavilion.destroy, GAMEMODE.pointerToLevel, 0, 0, 1));
                //showing the HUD above everything else
                GAMEMODE.pointerToLevel.bringHUDToTop();
            }
        }

        pavilion.startGame = function () {
            pavilion.target = addActor(GAMEMODE.pointerToLevel, 272, 397, "target", 64, 64, 500, false, null, null, true);
            pavilion.target.anchor.setTo(0.5, 0.5);
            pavilion.makeTween();
            pavilion.actors.push(pavilion.target);
            pavilion.btnShoot = GAMEMODE.pointerToLevel.add.button(10, 490, "shootBtn", pavilion.shootBtnHandler, GAMEMODE.pointerToLevel, 0, 0, 1);
            pavilion.actors.push(pavilion.btnShoot);
        }

        pavilion.endGame = function () {
            pavilion.gameCompleted = true;
            pavilion.mishena.rotation -= 45;
            pavilion.prychka.rotation += 45;
            pavilion.prychka.x = 379;
            pavilion.prychka.y = 438;
            pavilion.clownLegen.visible = true;
            pavilion.clown.visible = false;
            pavilion.target.visible = false;
            pavilion.btnShoot.visible = false;
        }
        pavilion.destroy = function () {
            pavilion.actors.forEach(function (actor) {
                actor.destroy();
            });
            pavilion.actors = [];
            pavilion.target = null;
            pavilion.prychka = null;
            pavilion.btnShoot = null;
            pavilion.mishena = null;
            pavilion.clownLegen = null;
            pavilion.clown = null;
            GAMEMODE.pointerToLevel.cameraMan.x = GAMEMODE.pointerToLevel.cameraXBeforeSmallScene;
            pavilion.pavilionShown = false;
        }

        pavilion.makeTween = function () {
            if (!pavilion.gameCompleted) {
                var newCoords = pavilion.getCoords();
                tween = GAMEMODE.pointerToLevel.add.tween(pavilion.target).to({ x: newCoords.x, y: newCoords.y }, 650);
                tween.onComplete.add(pavilion.makeTween, this);
                tween.start();
            }
        }

        pavilion.getCoords = function () {
            var minX = 272, minY = 397, maxX = 356, maxY = 478;
            return { x: getRandomIntInclusive(minX, maxX), y: getRandomIntInclusive(minY, maxY) };
        }

        pavilion.shootBtnHandler = function () {
            if (pavilion.canShoot) {
                //play sound
                if (MUSICMANAGER.shoot) {
                    MUSICMANAGER.shoot.play();
                }
                pavilion.canShoot = false;
                tween.stop();
                pavilion.target.frame = 1;
                //check If I win
                if (isOnTarget(pavilion.target.x, pavilion.target.y)) {
                    pavilion.endGame();
                }
                else {
                    setTimeout(function () {
                        pavilion.canShoot = true;
                        pavilion.target.frame = 0;
                        pavilion.makeTween();
                    }, 1000);
                }
            }
        }

        function isOnTarget(x, y) {
            return x >= 302 && y >= 437 && x <= 321 && y <= 453;
        }

        return pavilion;
    },
    setUpSounds: function () {
        if (!MUSICMANAGER.shoot) {
            MUSICMANAGER.shoot = new Media(cordova.file.applicationDirectory + "www/assets/Audio/shoot.mp3", function () { },
                function (err) {
                    MUSICMANAGER.shoot = null;
                });
        }

        if (!MUSICMANAGER.bell) {
            MUSICMANAGER.bell = new Media(cordova.file.applicationDirectory + "www/assets/Audio/bell.mp3", function () { },
                function (err) {
                    MUSICMANAGER.bell = null;
                });
        }

        if (!MUSICMANAGER.kukuvichka) {
            MUSICMANAGER.kukuvichka = new Media(cordova.file.applicationDirectory + "www/assets/Audio/kukuvichka.mp3", function () { },
                function (err) {
                    MUSICMANAGER.kukuvichka = null;
                });
        }
    }
};