﻿var level5 = function (game) { };
level5.prototype = {
    mouseX: 0,
    oldMouseX: 0,
    itemSelected: null,
    preload: function () {
        //loading screen
        this.loadBck = this.add.sprite(0, 0, "loadingBackground");
        this.loadingHearts = [];
        this.atLoading = 1;
        for (var i = 0; i < 6; i++) {
            this.loadingHearts.push(this.add.sprite(133 + (i * 128), 439, "loading"));
            this.loadingHearts[i].visible = false;
        }
        game.load.onFileComplete.add(fileComplete, this);
        game.load.onLoadComplete.add(loadComplete, this);

        this.load.image("hud_big", "assets/hud3.png");
        //secondary
        this.load.image("background", "assets/Level_5/background.png");
        this.load.spritesheet("smallscenes0", "assets/Level_5/smallscenes0.png", 1024, 768);
        this.load.spritesheet("sprite_saksiq_cvete", "assets/Level_5/items/sprite_saksiq_cvete.png", 111, 180);
        this.load.image("semki_sakciq", "assets/Level_5/items/semki_sakciq.png");
        this.load.spritesheet("sprite_lampa_lqvo_zel", "assets/Level_5/items/sprite_lampa_lqvo_zel.png", 141, 120);
        this.load.spritesheet("sprite_lampa_vdqsno", "assets/Level_5/items/sprite_lampa_vdqsno.png", 141, 120);
        this.load.spritesheet("sprite_statuq", "assets/Level_5/items/sprite_statuq.png", 88, 92);
        this.load.image("kletka_slojena_pravilno", "assets/Level_5/items/kletka_slojena_pravilno.png");
        this.load.spritesheet("bsLightLeft", "assets/Level_5/bsLightLeft.png", 180, 90);
        this.load.spritesheet("bsLightRight", "assets/Level_5/bsLightRight.png", 180, 90);

        //items
        this.load.image("item_bradva", "assets/Level_5/items/item_bradva.png");
        this.load.image("item_leika", "assets/Level_5/items/item_leika.png");
        this.load.image("item_semki", "assets/Level_5/items/item_semki.png");
        this.load.image("item_zapalka", "assets/Level_5/items/item_zapalka.png");
        this.load.image("item_kletka", "assets/Level_5/items/item_kletka.png");
        this.load.image("item_realno_kupa", "assets/Level_5/items/item_realno_kupa.png");
        this.load.image("item_tuba_bendji", "assets/Level_5/items/item_tuba_bendji.png");
        this.load.image("item_lostche", "assets/Level_5/items/item_lostche.png");
        this.load.image("item_pruchka", "assets/Level_5/items/item_pruchka.png");
        this.load.spritesheet("kletka_jivotno", "assets/Level_5/items/kletka_jivotno.png", 377, 295);
        this.load.spritesheet("item_dyneri", "assets/Level_5/items/item_dyneri.png", 200, 200);
        this.load.spritesheet("item_zvezda_forma", "assets/Level_5/items/item_zvezda_forma.png", 160, 85);
        this.load.image("item_prychica_v_ryka", "assets/Level_5/items/item_prychica_v_ryka.png");

        //hud items
        this.load.image("501", "assets/Level_5/HUD/501.png");
        this.load.image("502", "assets/Level_5/HUD/502.png");
        this.load.image("503", "assets/Level_5/HUD/503.png");
        this.load.image("504", "assets/Level_5/HUD/504.png");
        this.load.image("505", "assets/Level_5/HUD/505.png");
        this.load.image("506", "assets/Level_5/HUD/506.png");
        this.load.image("507", "assets/Level_5/HUD/507.png");
        this.load.image("508", "assets/Level_5/HUD/508.png");
        this.load.image("509", "assets/Level_5/HUD/509.png");
        this.load.image("510", "assets/Level_5/HUD/510.png");
        this.load.image("511", "assets/Level_5/HUD/511.png");
        this.load.image("512", "assets/Level_5/HUD/512.png");
        this.load.image("514", "assets/Level_5/HUD/514.png");
        this.load.image("515", "assets/Level_5/HUD/515.png");
        this.load.image("516", "assets/Level_5/HUD/516.png");
        this.load.image("517", "assets/Level_5/HUD/517.png");
    },
    create: function () {
        resetHintTimer(true);

        //resetingShits and basic stuff for a level
        GAMEMODE.levelNumber = 5;
        GAMEMODE.pointerToLevel = this;
        this.cameraXBeforeSmallScene = 512;
        this.cameraMove = false;
        this.paused = false;
        this.videoPlaying = false;
        this.itemSelected = null;
        this.mouseX = 0;
        this.oldMouseX = 0;

        //stek sydyrjasht listove ot itemi, koito da se kriqt
        this.itemsToHide = [];
        //list sydyrjasht actiori, koito moje da tick- vat
        this.tickingActors = {};
        setUpALevel(this);
        makeHUDItems(this);

        ////reseting other basic variable sfor this particular level
        this.videoManager = {};
        this.videoManager[GAMEMODE.videoNames[9]] = false;

        //sets the left and right circle lights in the big level
        this.leftCircleLight = addActor(this, 289, 173, "bsLightLeft", 180, 90, 201, false, {}, {}, true);
        this.rightCircleLight = addActor(this, 1361, 196, "bsLightRight", 180, 90, 201, false, {}, {}, true);
        this.smallScene.bringToTop();

        this.showBendji = false;
        this.showLeika = false;

        this.leftSide = addActor(this, 93, 155, "camera", 300, 500, 1, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.showBendji) {
                    if (!game.bendji.taken) {
                        game.bendji.visible = true;
                    }
                }
                game.kletkaVRyka.visible = true;
                game.lampaLqvo.visible = true;
                game.glavaStatuqLqvo.visible = true;
                game.dyrva.visible = true;
                game.kniga.visible = true;
                game.textLeft.visible = true;
            },
            getListToHide: function (game) {
                var returnV = [];
                if (!game.bendji.taken) {
                    returnV.push(game.bendji);
                }

                returnV.push(game.kletkaVRyka);
                returnV.push(game.lampaLqvo);
                returnV.push(game.glavaStatuqLqvo);
                returnV.push(game.dyrva);
                returnV.push(game.kniga);
                returnV.push(game.textLeft);
                return returnV;
            }
        }, true);

        this.rightSide = addActor(this, 1355, 170, "camera", 300, 500, 3, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (game.showLeika) {
                    if (!game.leika.taken) {
                        game.leika.visible = true;
                    }
                }
                if (!game.saksiq.taken) {
                    game.saksiq.visible = true;
                }
                if (game.saksiq.id === 101) {
                    game.semkiVSaksiq.visible = true;
                }
                game.lampaDqsno.visible = true;
                game.doJena.visible = true;
                game.slojenaPrychica.visible = true;
                game.textRight.visible = true;

                if (!game.magicheskaPrychica.taken) {
                    game.magicheskaPrychica.visible = true;
                }
            },
            getListToHide: function (game) {
                var returnV = [];
                if (!game.leika.taken) {
                    returnV.push(game.leika);
                }

                if (!game.magicheskaPrychica.taken) {
                    returnV.push(game.magicheskaPrychica);
                }
                if (!game.saksiq.taken) {
                    returnV.push(game.saksiq);
                }

                returnV.push(game.semkiVSaksiq);

                returnV.push(game.slojenaPrychica);
                returnV.push(game.lampaDqsno);
                returnV.push(game.doJena);
                returnV.push(game.textRight);

                return returnV;
            }
        }, true);

        this.centralSide = addActor(this, 741, 155, "camera", 250, 500, 2, true, this.changeSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityHandlerShow: function (game) {
                if (!game.bradva.taken) {
                    game.bradva.visible = true;
                }
                if (!game.kletka.taken) {
                    game.kletka.visible = true;
                }
                if (!game.kupa.taken) {
                    game.kupa.visible = true;
                }
                game.vodaBlizo.visible = true;
                game.dupkaBlizo.visible = true;

                if (game.lampaLqvo.frame === 1 && game.lampaDqsno.frame === 1) {
                    game.vrata.visible = true;
                }
            },
            getListToHide: function (game) {
                var returnV = [];
                if (!game.bradva.taken) {
                    returnV.push(game.bradva);
                }
                if (!game.kletka.taken) {
                    returnV.push(game.kletka);
                }
                if (!game.kupa.taken) {
                    returnV.push(game.kupa);
                }
                returnV.push(game.vodaBlizo);
                returnV.push(game.dupkaBlizo);

                if (game.lampaLqvo.frame === 1 && game.lampaDqsno.frame === 1) {
                    returnV.push(game.vrata);
                }
                return returnV;
            }
        }, true);
        //smalscene changers
        //mejdinni sceni
        this.doJena = addActor(this, 409, 507, "camera", 122, 62, 6, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                //include files that are going to be visible on the next scene
                if (!game.semki.taken) {
                    game.semki.visible = true;
                }
                if (!game.zapalka.taken) {
                    game.zapalka.visible = true;
                }
                game.itemsToHide.push([game.semki, game.zapalka]);
            }
        }, false);

        this.kniga = addActor(this, 238, 655, "camera", 150, 100, 7, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                game.itemsToHide.push([]);
            }
        }, false);

        this.dupkaBlizo = addActor(this, 832, 492, "camera", 150, 150, 5, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                //include files that are going to be visible on the next scene
                if (!game.kletkaZaredena.taken) {
                    game.kletkaZaredena.visible = true;
                }
                game.itemsToHide.push([game.kletkaZaredena]);
            }
        }, false);

        this.vodaBlizo = addActor(this, 6, 360, "camera", 150, 150, 4, true, this.handleSmallScenes, {
            event: this,
            scene: this.smallScene,
            visibilityAndActionHandler: function (game) {
                game.popListToHide();
                //include files that are going to be visible on the next scene
                game.voda.visible = true;
                if (!game.lost.taken) {
                    game.lost.visible = true;
                }
                if (!game.zvezda.taken) {
                    game.zvezda.visible = true;
                }

                game.itemsToHide.push([game.voda, game.lost, game.zvezda]);
            }
        }, false);

        //Iteractive items
        this.saksiq = addActor(this, 549, 544, "sprite_saksiq_cvete", 111, 180, 100, true, function (e) {
            if (e.id === 100 && this.itemSelected && this.itemSelected.id === 503) {
                removeItemFromHUD(this);
                e.id = 101;
                this.semkiVSaksiq.visible = true;
            }
            else if (e.id === 101 && this.itemSelected && this.itemSelected.id === 511) {
                removeItemFromHUD(this);
                e.id = 512;
                e.frame = 1;
                this.semkiVSaksiq.visible = false;
            }
            else if (e.id === 512) {
                if (takeItem.apply({ game: this }, [e])) {
                    e.id === 102;
                    e.frame = 0;
                }
            }
        }, this, false);
        this.saksiq.taken = false;

        this.semkiVSaksiq = addActor(this, 595, 615, "semki_sakciq", 32, 32, 110, true, function (e) {
            if (this.saksiq.id === 101 && this.itemSelected && this.itemSelected.id === 511) {
                removeItemFromHUD(this);
                this.saksiq.id = 512;
                this.saksiq.frame = 1;
                e.visible = false;
            }
        }, this, false);
        this.lampaLqvo = addActor(this, 446, 93, "sprite_lampa_lqvo_zel", 141, 120, 130, true, function (e) {
        }, this, false);
        this.lampaDqsno = addActor(this, 212, 180, "sprite_lampa_vdqsno", 141, 120, 140, true, function (e) {
        }, this, false);

        function alertDismissed() { }

        this.textLeft = addActor(this, 199, 530, "camera", 150, 100, 200, true, function (e) {
            navigator.notification.alert("'I've always dreamed to have a blue whiteheaded dragon in my hand.'",  // message
               alertDismissed,         // callback
                'Label',            // title
                'OK'            // buttonName
               );
        }, this, false);
        this.textRight = addActor(this, 370, 576, "camera", 150, 100, 200, true, function (e) {
            navigator.notification.alert("'I've always wanted to be a fairy.'",  // message
               alertDismissed,         // callback
                'Label',            // title
                'OK'            // buttonName
               );
        }, this, false);
        this.glavaStatuqLqvo = addActor(this, 287, 105, "sprite_statuq", 88, 92, 150, true, function (e) {
            if (e.frame === 1 && this.itemSelected && this.itemSelected.id === 508) {
                removeItemFromHUD(this);
                this.leftCircleLight.frame = 1;
                this.lampaLqvo.frame = 1;
                e.frame = 2;
            }
        }, this, false);
        this.kletkaVRyka = addActor(this, 355, 106, "camera", 118, 114, 150, true, function (e) { //"kletka_slojena_pravilno"
            if (e.id === 150 && this.itemSelected && this.itemSelected.id === 509) {
                removeItemFromHUD(this);
                e.loadTexture("kletka_slojena_pravilno");
                setSizeActor(e, 118, 114);
                this.glavaStatuqLqvo.frame = 1;
            }
        }, this, false);
        this.kletkaZaredena = addActor(this, 235, 278, "camera", 377, 295, 160, true, function (e) { //"kletka_jivotno"
            if (e.id === 160 && this.itemSelected && this.itemSelected.id === 515) {
                console.log("here");
                removeItemFromHUD(this);
                e.loadTexture("kletka_jivotno");
                setSizeActor(e, 377, 295);
                setTimeout(function () {
                    //PLAY SOUND
                    if (MUSICMANAGER.trapSnap) {
                        MUSICMANAGER.trapSnap.play();
                    }
                    e.id = 509;
                    e.frame = 1;
                }, 2000);
            }
            else if (e.id === 509) {
                takeItem.apply({ game: this }, [e]);
            }
        }, this, false);
        this.kletkaZaredena.taken = false;

        this.voda = addActor(this, 159, 298, "camera", 450, 150, 511, true, function (e) {
            if (this.itemSelected && this.itemSelected.id === 502) {
                removeItemFromHUD(this);
                takeItem.apply({ game: this }, [e]);
            }
        }, this, false);

        this.lost = addActor(this, 85, 385, "item_lostche", 47, 325, 508, true, function (e) {
            takeItem.apply({ game: this }, [e]);
        }, this, false);
        this.lost.taken = false;

        this.bradva = addActor(this, 328, 289, "item_bradva", 111, 371, 501, true, function (e) {
            if (takeItem.apply({ game: this }, [e])) {
                this.showBendji = true;
            }
        }, this, false);
        this.bradva.taken = false;

        this.semki = addActor(this, 401, 7, "item_semki", 329, 433, 503, true, function (e) {
            if (takeItem.apply({ game: this }, [e])) {
                this.showLeika = true;
            }
        }, this, false);
        this.semki.taken = false;

        this.dyrva = addActor(this, 479, 528, "item_dyneri", 200, 200, 513, true, function (e) {
            if (e.frame === 0 && this.itemSelected && this.itemSelected.id === 501) {
                removeItemFromHUD(this);
                e.frame = 1;
            }
            else if (e.frame === 1 && this.itemSelected && this.itemSelected.id === 507) {
                removeItemFromHUD(this);
                e.frame = 2;
            }
            else if (e.frame === 2 && this.itemSelected && this.itemSelected.id === 504) {
                removeItemFromHUD(this);
                e.frame = 3;
                e.id = 514;
            }
            else if (e.frame === 3 && this.itemSelected && this.itemSelected.id === 506) {
                removeItemFromHUD(this);
                takeItem.apply({ game: this }, [e]);
                e.visible = true;
            }
        }, this, false);

        this.zvezda = addActor(this, 589, 344, "item_zvezda_forma", 160, 85, 516, true, function (e) {
            if (e.frame === 0 && this.itemSelected && this.itemSelected.id === 514) {
                removeItemFromHUD(this);
                e.frame = 1;
            }
            else if (e.frame === 1) {
                takeItem.apply({ game: this }, [e]);
            }
        }, this, false);
        this.zvezda.taken = false;

        this.slojenaPrychica = addActor(this, 426, 254, "camera", 95, 42, 190, true, function (e) {
            if (this.itemSelected && this.itemSelected.id === 517) {
                removeItemFromHUD(this);
                e.loadTexture("item_prychica_v_ryka");
                setSizeActor(e, 95, 42);
                this.lampaDqsno.frame = 1;
                this.rightCircleLight.frame = 1;
            }
        }, this, false);

        this.vrata = addActor(this, 255, 211, "camera", 310, 400, 200, true, function () {
            this.videoHandler.apply({ game: this, videoName: GAMEMODE.videoNames[9] }, []);
        }, this, false);

        //takable items
        //501 bradva
        this.leika = addTakableItem(addActor(this, 129, 568, "item_leika", 138, 167, 502, true,
takeItem, { game: this }, false));
        //503 semki
        this.zapalka = addTakableItem(addActor(this, 35, 321, "item_zapalka", 173, 115, 504, true,
takeItem, { game: this }, false));
        this.kletka = addTakableItem(addActor(this, 572, 570, "item_kletka", 200, 198, 505, true,
takeItem, { game: this }, false));
        this.kupa = addTakableItem(addActor(this, 68, 469, "item_realno_kupa", 100, 80, 506, true,
takeItem, { game: this }, false));
        this.bendji = addTakableItem(addActor(this, 47, 546, "item_tuba_bendji", 67, 137, 507, true,
takeItem, { game: this }, false));
        this.magicheskaPrychica = addTakableItem(addActor(this, 426, 718, "item_pruchka", 99, 43, 510, true,
takeItem, { game: this }, false));
        //511 leika pylna s voda
        //512 cvetq
        //514 raztopena kupa
        //515 kletka s cvete vytre
        //516 zvezda pylna i gotova
        //517 gotova prychica


        //showing the HUD above everything else
        this.bringHUDToTop();

        //show ad
        showInterstitial();
    },
    update: function () {
        if (!this.paused) {
            if (this.cameraMove && !this.smallScene.shown) {
                this.mouseX = this.input.x;
                this.cameraMan.x = this.cameraMan.x - (this.mouseX - this.oldMouseX);
                if (this.cameraMan.x > 1536)
                    this.cameraMan.x = 1536;
                else if (this.cameraMan.x < 512)
                    this.cameraMan.x = 512;
                //compute the kolelce new frame
                var razlika = this.mouseX - this.kolelce.lastMoved;
                if (Math.abs(razlika) > 20 && this.cameraMan.x != 512 && this.cameraMan.x != 1536) {
                    var direction = razlika > 0 ? -1 : 1;
                    this.kolelce.frame = this.kolelce.frame === 0 && direction === -1 ? 2 : (this.kolelce.frame + direction) % 3;
                    this.kolelce.lastMoved = this.mouseX;
                }

                this.oldMouseX = this.mouseX;
            }
        }
        for (var property in this.tickingActors) {
            if (this.tickingActors.hasOwnProperty(property) && this.tickingActors[property].isTicking) {
                this.tickingActors[property].tick();
            }
        }
    },
    changeSmallScenes: function (e) {
        if (!this.scene.shown && !this.event.paused) {
            //resets cameraview
            this.event.cameraXBeforeSmallScene = this.event.cameraMan.x;
            this.event.cameraMan.x = 512;

            //shows the small scenes
            this.scene.width = 1024;
            this.scene.height = 768;
            this.scene.id = e.id;
            if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
                this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
            this.scene.frame = (e.id - 1) % 8;
            this.scene.shown = true;

            //ako trqbva specialni neshta ako trqbva da se pokajat
            if (this.visibilityHandlerShow !== null)
                this.visibilityHandlerShow(this.event);

            //vkarva list s itemite koito trqbva da se skriqt
            if (this.getListToHide) {
                var list = this.getListToHide(this.event);
                if (list) {
                    this.event.itemsToHide.push(list);
                }
            }
            //adds back Btnton
            this.event.backBtn = this.event.add.button(10, 630, "backBtn", this.event.backBtnHandler, {
                event: this.event,
                scene: this.scene
            }, 0, 0, 1);
        }
    },
    handleSmallScenes: function (e) {
        if (this.scene.key !== "smallscenes" + Math.floor((e.id - 1) / 8))
            this.scene.loadTexture("smallscenes" + Math.floor((e.id - 1) / 8));
        this.scene.id = e.id;
        this.scene.frame = (e.id - 1) % 8;
        if (this.visibilityAndActionHandler)
            this.visibilityAndActionHandler(this.event);
    },
    videoHandler: function (e) {
        var pointerToThis = this;
        if (!this.game.videoManager[this.videoName]) {
            //otbelqzva tova video kato gledano
            this.game.videoManager[this.videoName] = true;

            //pause music videoto
            pauseMusicForVideo();

            GAMEMODE.pointerToLevel.videoPlaying = true;
            playPlayer(game.videos[this.videoName]);
            setTimeout(function () {
                game.videos[pointerToThis.videoName].callback();
                if (e) {
                    e.destroy();
                    e = null;
                }
            }, 2000);
        }
    },
    backBtnHandler: function (e) {
        if (!this.videoPlaying) {
            this.event.cameraMan.x = this.event.cameraXBeforeSmallScene;
            this.scene.width = 0;
            this.scene.height = 0;
            this.scene.id = -1;
            this.scene.shown = false;

            while (this.event.itemsToHide.length > 0)
                this.event.popListToHide();
            e.kill();
            this.event.backBtn = null;
        }
    },
    popListToHide: function () {
        var list = this.itemsToHide.pop();
        for (var i = 0; i < list.length; i++)
            if (list[i] && list[i].visible)
                list[i].visible = false;
    },
    pushAtTopListToHide: function (list) {
        for (var i = 0; i < list.length; i++) {
            this.itemsToHide[this.itemsToHide.length - 1].push(list[i]);
        }
    },
    bringHUDToTop: function () {
        this.HUD.bringToTop();
        for (var i = 0; i < this.hudItems.length; i++)
            this.hudItems[i].bringToTop();
        this.selector.bringToTop();
    }
};